/* DockSurface.c generated by valac 0.28.1, the Vala compiler
 * generated from DockSurface.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <string.h>


#define PLANK_DRAWING_TYPE_DOCK_SURFACE (plank_drawing_dock_surface_get_type ())
#define PLANK_DRAWING_DOCK_SURFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_DRAWING_TYPE_DOCK_SURFACE, PlankDrawingDockSurface))
#define PLANK_DRAWING_DOCK_SURFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_DRAWING_TYPE_DOCK_SURFACE, PlankDrawingDockSurfaceClass))
#define PLANK_DRAWING_IS_DOCK_SURFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_DRAWING_TYPE_DOCK_SURFACE))
#define PLANK_DRAWING_IS_DOCK_SURFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_DRAWING_TYPE_DOCK_SURFACE))
#define PLANK_DRAWING_DOCK_SURFACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_DRAWING_TYPE_DOCK_SURFACE, PlankDrawingDockSurfaceClass))

typedef struct _PlankDrawingDockSurface PlankDrawingDockSurface;
typedef struct _PlankDrawingDockSurfaceClass PlankDrawingDockSurfaceClass;
typedef struct _PlankDrawingDockSurfacePrivate PlankDrawingDockSurfacePrivate;
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define PLANK_DRAWING_TYPE_COLOR (plank_drawing_color_get_type ())
typedef GdkRGBA PlankDrawingColor;
typedef struct _Block4Data Block4Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PlankDrawingDockSurface {
	GObject parent_instance;
	PlankDrawingDockSurfacePrivate * priv;
};

struct _PlankDrawingDockSurfaceClass {
	GObjectClass parent_class;
};

struct _PlankDrawingDockSurfacePrivate {
	cairo_surface_t* _Internal;
	gint _Width;
	gint _Height;
	cairo_t* _Context;
};

struct _Block4Data {
	int _ref_count_;
	PlankDrawingDockSurface* self;
	gint alpha;
	gint height;
	gint width;
	guint8* pixels;
};

struct _Block5Data {
	int _ref_count_;
	PlankDrawingDockSurface* self;
	gint gaussWidth;
	gdouble* kernel;
	gint kernel_length1;
	gint _kernel_size_;
	gint width;
	gint height;
	gdouble* abuffer;
	gint abuffer_length1;
	gint _abuffer_size_;
	gdouble* bbuffer;
	gint bbuffer_length1;
	gint _bbuffer_size_;
	gint* shiftar;
	gint shiftar_length1;
	gint shiftar_length2;
	gint _shiftar_size_;
};


static gpointer plank_drawing_dock_surface_parent_class = NULL;

GType plank_drawing_dock_surface_get_type (void) G_GNUC_CONST;
#define PLANK_DRAWING_DOCK_SURFACE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PLANK_DRAWING_TYPE_DOCK_SURFACE, PlankDrawingDockSurfacePrivate))
enum  {
	PLANK_DRAWING_DOCK_SURFACE_DUMMY_PROPERTY,
	PLANK_DRAWING_DOCK_SURFACE_INTERNAL,
	PLANK_DRAWING_DOCK_SURFACE_WIDTH,
	PLANK_DRAWING_DOCK_SURFACE_HEIGHT,
	PLANK_DRAWING_DOCK_SURFACE_CONTEXT
};
#define PLANK_DRAWING_DOCK_SURFACE_AlphaPrecision 16
#define PLANK_DRAWING_DOCK_SURFACE_ParamPrecision 7
PlankDrawingDockSurface* plank_drawing_dock_surface_new (gint width, gint height);
PlankDrawingDockSurface* plank_drawing_dock_surface_construct (GType object_type, gint width, gint height);
PlankDrawingDockSurface* plank_drawing_dock_surface_new_with_surface (gint width, gint height, cairo_surface_t* model);
PlankDrawingDockSurface* plank_drawing_dock_surface_construct_with_surface (GType object_type, gint width, gint height, cairo_surface_t* model);
PlankDrawingDockSurface* plank_drawing_dock_surface_new_with_dock_surface (gint width, gint height, PlankDrawingDockSurface* model);
PlankDrawingDockSurface* plank_drawing_dock_surface_construct_with_dock_surface (GType object_type, gint width, gint height, PlankDrawingDockSurface* model);
cairo_surface_t* plank_drawing_dock_surface_get_Internal (PlankDrawingDockSurface* self);
PlankDrawingDockSurface* plank_drawing_dock_surface_new_with_internal (cairo_surface_t* image);
PlankDrawingDockSurface* plank_drawing_dock_surface_construct_with_internal (GType object_type, cairo_surface_t* image);
void plank_drawing_dock_surface_clear (PlankDrawingDockSurface* self);
cairo_t* plank_drawing_dock_surface_get_Context (PlankDrawingDockSurface* self);
PlankDrawingDockSurface* plank_drawing_dock_surface_copy (PlankDrawingDockSurface* self);
gint plank_drawing_dock_surface_get_Width (PlankDrawingDockSurface* self);
gint plank_drawing_dock_surface_get_Height (PlankDrawingDockSurface* self);
PlankDrawingDockSurface* plank_drawing_dock_surface_scaled_copy (PlankDrawingDockSurface* self, gint width, gint height);
GdkPixbuf* plank_drawing_dock_surface_to_pixbuf (PlankDrawingDockSurface* self);
PlankDrawingDockSurface* plank_drawing_dock_surface_create_mask (PlankDrawingDockSurface* self, gdouble threshold, GdkRectangle* extent);
GType plank_drawing_color_get_type (void) G_GNUC_CONST;
PlankDrawingColor* plank_drawing_color_dup (const PlankDrawingColor* self);
void plank_drawing_color_free (PlankDrawingColor* self);
void plank_drawing_dock_surface_average_color (PlankDrawingDockSurface* self, PlankDrawingColor* result);
void plank_drawing_drawing_service_average_color (GdkPixbuf* source, PlankDrawingColor* result);
void plank_drawing_dock_surface_fast_blur (PlankDrawingDockSurface* self, gint radius, gint process_count);
void plank_drawing_dock_surface_exponential_blur (PlankDrawingDockSurface* self, gint radius);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void* __lambda4_ (Block4Data* _data4_);
static void plank_drawing_dock_surface_exponential_blur_rows (PlankDrawingDockSurface* self, guint8* pixels, gint width, gint height, gint startRow, gint endRow, gint startX, gint endX, gint alpha);
static gpointer ___lambda4__gthread_func (gpointer self);
static void* __lambda5_ (Block4Data* _data4_);
static void plank_drawing_dock_surface_exponential_blur_columns (PlankDrawingDockSurface* self, guint8* pixels, gint width, gint height, gint startCol, gint endCol, gint startY, gint endY, gint alpha);
static gpointer ___lambda5__gthread_func (gpointer self);
static inline void plank_drawing_dock_surface_exponential_blur_inner (guint8* pixel, gint* zA, gint* zR, gint* zG, gint* zB, gint alpha);
void plank_drawing_dock_surface_gaussian_blur (PlankDrawingDockSurface* self, gint radius);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gdouble* plank_drawing_dock_surface_build_gaussian_kernel (gint gaussWidth, int* result_length1);
static void* __lambda6_ (Block5Data* _data5_);
static void plank_drawing_dock_surface_gaussian_blur_horizontal (PlankDrawingDockSurface* self, gdouble* src, gdouble* dest, gdouble* kernel, gint gaussWidth, gint width, gint height, gint startRow, gint endRow, gint* shift, int shift_length1, int shift_length2);
static gpointer ___lambda6__gthread_func (gpointer self);
static void* __lambda7_ (Block5Data* _data5_);
static void plank_drawing_dock_surface_gaussian_blur_vertical (PlankDrawingDockSurface* self, gdouble* src, gdouble* dest, gdouble* kernel, gint gaussWidth, gint width, gint height, gint startCol, gint endCol, gint* shift, int shift_length1, int shift_length2);
static gpointer ___lambda7__gthread_func (gpointer self);
static void plank_drawing_dock_surface_set_Internal (PlankDrawingDockSurface* self, cairo_surface_t* value);
static void plank_drawing_dock_surface_set_Width (PlankDrawingDockSurface* self, gint value);
static void plank_drawing_dock_surface_set_Height (PlankDrawingDockSurface* self, gint value);
static void plank_drawing_dock_surface_set_Context (PlankDrawingDockSurface* self, cairo_t* value);
static GObject * plank_drawing_dock_surface_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void plank_drawing_dock_surface_finalize (GObject* obj);
static void _vala_plank_drawing_dock_surface_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_plank_drawing_dock_surface_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Creates a new dock surface.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 */
PlankDrawingDockSurface* plank_drawing_dock_surface_construct (GType object_type, gint width, gint height) {
	PlankDrawingDockSurface * self = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	cairo_surface_t* _tmp4_ = NULL;
	cairo_surface_t* _tmp5_ = NULL;
	_tmp0_ = width;
	_tmp1_ = height;
	_tmp2_ = width;
	_tmp3_ = height;
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp2_, _tmp3_);
	_tmp5_ = _tmp4_;
	self = (PlankDrawingDockSurface*) g_object_new (object_type, "Width", _tmp0_, "Height", _tmp1_, "Internal", _tmp5_, NULL);
	_cairo_surface_destroy0 (_tmp5_);
	return self;
}


PlankDrawingDockSurface* plank_drawing_dock_surface_new (gint width, gint height) {
	return plank_drawing_dock_surface_construct (PLANK_DRAWING_TYPE_DOCK_SURFACE, width, height);
}


/**
 * Creates a new dock surface compatible with an existing {@link Cairo.Surface}.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 * @param model existing {@link Cairo.Surface} to be similar to
 */
PlankDrawingDockSurface* plank_drawing_dock_surface_construct_with_surface (GType object_type, gint width, gint height, cairo_surface_t* model) {
	PlankDrawingDockSurface * self = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	cairo_surface_t* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	cairo_surface_t* _tmp5_ = NULL;
	cairo_surface_t* _tmp6_ = NULL;
	g_return_val_if_fail (model != NULL, NULL);
	_tmp0_ = width;
	_tmp1_ = height;
	_tmp2_ = model;
	_tmp3_ = width;
	_tmp4_ = height;
	_tmp5_ = cairo_surface_create_similar (_tmp2_, CAIRO_CONTENT_COLOR_ALPHA, _tmp3_, _tmp4_);
	_tmp6_ = _tmp5_;
	self = (PlankDrawingDockSurface*) g_object_new (object_type, "Width", _tmp0_, "Height", _tmp1_, "Internal", _tmp6_, NULL);
	_cairo_surface_destroy0 (_tmp6_);
	return self;
}


PlankDrawingDockSurface* plank_drawing_dock_surface_new_with_surface (gint width, gint height, cairo_surface_t* model) {
	return plank_drawing_dock_surface_construct_with_surface (PLANK_DRAWING_TYPE_DOCK_SURFACE, width, height, model);
}


/**
 * Creates a new dock surface compatible with an existing {@link Drawing.DockSurface}.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 * @param model existing {@link Drawing.DockSurface} to be similar to
 */
PlankDrawingDockSurface* plank_drawing_dock_surface_construct_with_dock_surface (GType object_type, gint width, gint height, PlankDrawingDockSurface* model) {
	PlankDrawingDockSurface * self = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	PlankDrawingDockSurface* _tmp2_ = NULL;
	cairo_surface_t* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	cairo_surface_t* _tmp6_ = NULL;
	cairo_surface_t* _tmp7_ = NULL;
	g_return_val_if_fail (model != NULL, NULL);
	_tmp0_ = width;
	_tmp1_ = height;
	_tmp2_ = model;
	_tmp3_ = _tmp2_->priv->_Internal;
	_tmp4_ = width;
	_tmp5_ = height;
	_tmp6_ = cairo_surface_create_similar (_tmp3_, CAIRO_CONTENT_COLOR_ALPHA, _tmp4_, _tmp5_);
	_tmp7_ = _tmp6_;
	self = (PlankDrawingDockSurface*) g_object_new (object_type, "Width", _tmp0_, "Height", _tmp1_, "Internal", _tmp7_, NULL);
	_cairo_surface_destroy0 (_tmp7_);
	return self;
}


PlankDrawingDockSurface* plank_drawing_dock_surface_new_with_dock_surface (gint width, gint height, PlankDrawingDockSurface* model) {
	return plank_drawing_dock_surface_construct_with_dock_surface (PLANK_DRAWING_TYPE_DOCK_SURFACE, width, height, model);
}


/**
 * Creates a new dock surface with the given {@link Cairo.ImageSurface} as Internal.
 *
 * @param image existing {@link Cairo.ImageSurface} as Internal
 */
PlankDrawingDockSurface* plank_drawing_dock_surface_construct_with_internal (GType object_type, cairo_surface_t* image) {
	PlankDrawingDockSurface * self = NULL;
	cairo_surface_t* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	cairo_surface_t* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	cairo_surface_t* _tmp4_ = NULL;
	g_return_val_if_fail (image != NULL, NULL);
	_tmp0_ = image;
	_tmp1_ = cairo_image_surface_get_width (_tmp0_);
	_tmp2_ = image;
	_tmp3_ = cairo_image_surface_get_height (_tmp2_);
	_tmp4_ = image;
	self = (PlankDrawingDockSurface*) g_object_new (object_type, "Width", _tmp1_, "Height", _tmp3_, "Internal", _tmp4_, NULL);
	return self;
}


PlankDrawingDockSurface* plank_drawing_dock_surface_new_with_internal (cairo_surface_t* image) {
	return plank_drawing_dock_surface_construct_with_internal (PLANK_DRAWING_TYPE_DOCK_SURFACE, image);
}


/**
 * Clears the entire surface.
 */
void plank_drawing_dock_surface_clear (PlankDrawingDockSurface* self) {
	cairo_t* cr = NULL;
	cairo_t* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_Context;
	cr = _tmp0_;
	cairo_save (cr);
	cairo_set_operator (cr, CAIRO_OPERATOR_CLEAR);
	cairo_paint (cr);
	cairo_restore (cr);
}


/**
 * Create a copy of the surface
 *
 * @return copy of this surface
 */
PlankDrawingDockSurface* plank_drawing_dock_surface_copy (PlankDrawingDockSurface* self) {
	PlankDrawingDockSurface* result = NULL;
	PlankDrawingDockSurface* copy = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	PlankDrawingDockSurface* _tmp2_ = NULL;
	cairo_t* cr = NULL;
	cairo_t* _tmp3_ = NULL;
	cairo_surface_t* _tmp4_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Width;
	_tmp1_ = self->priv->_Height;
	_tmp2_ = plank_drawing_dock_surface_new_with_dock_surface (_tmp0_, _tmp1_, self);
	copy = _tmp2_;
	_tmp3_ = copy->priv->_Context;
	cr = _tmp3_;
	_tmp4_ = self->priv->_Internal;
	cairo_set_source_surface (cr, _tmp4_, (gdouble) 0, (gdouble) 0);
	cairo_paint (cr);
	result = copy;
	return result;
}


/**
 * Create a scaled copy of the surface
 *
 * @param width the resulting width
 * @param height the resulting height
 * @return scaled copy of this surface
 */
PlankDrawingDockSurface* plank_drawing_dock_surface_scaled_copy (PlankDrawingDockSurface* self, gint width, gint height) {
	PlankDrawingDockSurface* result = NULL;
	PlankDrawingDockSurface* _result_ = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	PlankDrawingDockSurface* _tmp2_ = NULL;
	cairo_t* cr = NULL;
	cairo_t* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	cairo_surface_t* _tmp8_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = width;
	_tmp1_ = height;
	_tmp2_ = plank_drawing_dock_surface_new_with_dock_surface (_tmp0_, _tmp1_, self);
	_result_ = _tmp2_;
	_tmp3_ = _result_->priv->_Context;
	cr = _tmp3_;
	cairo_save (cr);
	_tmp4_ = width;
	_tmp5_ = self->priv->_Width;
	_tmp6_ = height;
	_tmp7_ = self->priv->_Height;
	cairo_scale (cr, ((gdouble) _tmp4_) / _tmp5_, ((gdouble) _tmp6_) / _tmp7_);
	_tmp8_ = self->priv->_Internal;
	cairo_set_source_surface (cr, _tmp8_, (gdouble) 0, (gdouble) 0);
	cairo_paint (cr);
	cairo_restore (cr);
	result = _result_;
	return result;
}


/**
 * Saves the current dock surface to a {@link Gdk.Pixbuf}.
 *
 * @return the {@link Gdk.Pixbuf}
 */
GdkPixbuf* plank_drawing_dock_surface_to_pixbuf (PlankDrawingDockSurface* self) {
	GdkPixbuf* result = NULL;
	cairo_surface_t* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GdkPixbuf* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Internal;
	_tmp1_ = self->priv->_Width;
	_tmp2_ = self->priv->_Height;
	_tmp3_ = gdk_pixbuf_get_from_surface (_tmp0_, 0, 0, _tmp1_, _tmp2_);
	result = _tmp3_;
	return result;
}


/**
 * Computes the mask of the surface.
 *
 * @param threshold value defining the minimum opacity [0.0 .. 1.0]
 * @param extent bounding box of the found mask
 * @return a new surface containing the mask
 */
PlankDrawingDockSurface* plank_drawing_dock_surface_create_mask (PlankDrawingDockSurface* self, gdouble threshold, GdkRectangle* extent) {
	GdkRectangle _vala_extent = {0};
	PlankDrawingDockSurface* result = NULL;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	cairo_surface_t* surface = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	cairo_surface_t* _tmp4_ = NULL;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp5_ = NULL;
	cairo_t* _tmp6_ = NULL;
	cairo_t* _tmp7_ = NULL;
	cairo_t* _tmp8_ = NULL;
	cairo_surface_t* _tmp9_ = NULL;
	cairo_t* _tmp10_ = NULL;
	gint w = 0;
	cairo_surface_t* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gint h = 0;
	cairo_surface_t* _tmp13_ = NULL;
	gint _tmp14_ = 0;
	guint8 slice = 0U;
	gdouble _tmp15_ = 0.0;
	gint left = 0;
	gint _tmp16_ = 0;
	gint right = 0;
	gint top = 0;
	gint _tmp17_ = 0;
	gint bottom = 0;
	guint8* data = NULL;
	cairo_surface_t* _tmp18_ = NULL;
	guchar* _tmp19_ = NULL;
	gint src = 0;
	gboolean mask = FALSE;
	gint _tmp62_ = 0;
	gint _tmp63_ = 0;
	gint _tmp64_ = 0;
	gint _tmp65_ = 0;
	gint _tmp66_ = 0;
	gint _tmp67_ = 0;
	GdkRectangle _tmp68_ = {0};
	cairo_surface_t* _tmp69_ = NULL;
	PlankDrawingDockSurface* _tmp70_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = threshold;
	_tmp1_ = threshold;
	_vala_return_val_if_fail ((_tmp0_ >= 0.0) && (_tmp1_ <= 1.0), "threshold >= 0.0 && threshold <= 1.0", NULL);
	_tmp2_ = self->priv->_Width;
	_tmp3_ = self->priv->_Height;
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp2_, _tmp3_);
	surface = _tmp4_;
	_tmp5_ = surface;
	_tmp6_ = cairo_create (_tmp5_);
	cr = _tmp6_;
	_tmp7_ = cr;
	cairo_set_operator (_tmp7_, CAIRO_OPERATOR_SOURCE);
	_tmp8_ = cr;
	_tmp9_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp8_, _tmp9_, (gdouble) 0, (gdouble) 0);
	_tmp10_ = cr;
	cairo_paint (_tmp10_);
	_tmp11_ = surface;
	_tmp12_ = cairo_image_surface_get_width (_tmp11_);
	w = _tmp12_;
	_tmp13_ = surface;
	_tmp14_ = cairo_image_surface_get_height (_tmp13_);
	h = _tmp14_;
	_tmp15_ = threshold;
	slice = (guint8) (G_MAXUINT8 * _tmp15_);
	_tmp16_ = w;
	left = _tmp16_;
	right = 0;
	_tmp17_ = h;
	top = _tmp17_;
	bottom = 0;
	_tmp18_ = surface;
	_tmp19_ = cairo_image_surface_get_data (_tmp18_);
	data = _tmp19_;
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp20_ = FALSE;
			_tmp20_ = TRUE;
			while (TRUE) {
				gint _tmp22_ = 0;
				gint _tmp23_ = 0;
				if (!_tmp20_) {
					gint _tmp21_ = 0;
					_tmp21_ = y;
					y = _tmp21_ + 1;
				}
				_tmp20_ = FALSE;
				_tmp22_ = y;
				_tmp23_ = h;
				if (!(_tmp22_ < _tmp23_)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp24_ = FALSE;
						_tmp24_ = TRUE;
						while (TRUE) {
							gint _tmp26_ = 0;
							gint _tmp27_ = 0;
							gint _tmp28_ = 0;
							gint _tmp29_ = 0;
							gint _tmp30_ = 0;
							guint8* _tmp31_ = NULL;
							gint _tmp32_ = 0;
							guint8 _tmp33_ = 0U;
							guint8 _tmp34_ = 0U;
							guint8* _tmp35_ = NULL;
							gint _tmp36_ = 0;
							guint8 _tmp37_ = 0U;
							guint8* _tmp38_ = NULL;
							gint _tmp39_ = 0;
							guint8 _tmp40_ = 0U;
							guint8* _tmp41_ = NULL;
							gint _tmp42_ = 0;
							guint8 _tmp43_ = 0U;
							guint8 _tmp44_ = 0U;
							gboolean _tmp45_ = FALSE;
							guint8* _tmp46_ = NULL;
							gint _tmp47_ = 0;
							guint8 _tmp48_ = 0U;
							gboolean _tmp49_ = FALSE;
							if (!_tmp24_) {
								gint _tmp25_ = 0;
								_tmp25_ = x;
								x = _tmp25_ + 1;
							}
							_tmp24_ = FALSE;
							_tmp26_ = x;
							_tmp27_ = w;
							if (!(_tmp26_ < _tmp27_)) {
								break;
							}
							_tmp28_ = y;
							_tmp29_ = w;
							_tmp30_ = x;
							src = ((_tmp28_ * _tmp29_) + _tmp30_) * 4;
							_tmp31_ = data;
							_tmp32_ = src;
							_tmp33_ = _tmp31_[_tmp32_ + 3];
							_tmp34_ = slice;
							mask = _tmp33_ > _tmp34_;
							_tmp35_ = data;
							_tmp36_ = src;
							_tmp35_[_tmp36_ + 0] = (guint8) 0;
							_tmp37_ = _tmp35_[_tmp36_ + 0];
							_tmp38_ = data;
							_tmp39_ = src;
							_tmp38_[_tmp39_ + 1] = (guint8) 0;
							_tmp40_ = _tmp38_[_tmp39_ + 1];
							_tmp41_ = data;
							_tmp42_ = src;
							_tmp41_[_tmp42_ + 2] = (guint8) 0;
							_tmp43_ = _tmp41_[_tmp42_ + 2];
							_tmp45_ = mask;
							if (_tmp45_) {
								_tmp44_ = G_MAXUINT8;
							} else {
								_tmp44_ = (guint8) 0;
							}
							_tmp46_ = data;
							_tmp47_ = src;
							_tmp46_[_tmp47_ + 3] = _tmp44_;
							_tmp48_ = _tmp46_[_tmp47_ + 3];
							_tmp49_ = mask;
							if (_tmp49_) {
								gint _tmp50_ = 0;
								gint _tmp51_ = 0;
								gint _tmp53_ = 0;
								gint _tmp54_ = 0;
								gint _tmp56_ = 0;
								gint _tmp57_ = 0;
								gint _tmp59_ = 0;
								gint _tmp60_ = 0;
								_tmp50_ = y;
								_tmp51_ = top;
								if (_tmp50_ < _tmp51_) {
									gint _tmp52_ = 0;
									_tmp52_ = y;
									top = _tmp52_;
								}
								_tmp53_ = y;
								_tmp54_ = bottom;
								if (_tmp53_ > _tmp54_) {
									gint _tmp55_ = 0;
									_tmp55_ = y;
									bottom = _tmp55_;
								}
								_tmp56_ = x;
								_tmp57_ = left;
								if (_tmp56_ < _tmp57_) {
									gint _tmp58_ = 0;
									_tmp58_ = x;
									left = _tmp58_;
								}
								_tmp59_ = x;
								_tmp60_ = right;
								if (_tmp59_ > _tmp60_) {
									gint _tmp61_ = 0;
									_tmp61_ = x;
									right = _tmp61_;
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp62_ = left;
	_tmp63_ = top;
	_tmp64_ = right;
	_tmp65_ = left;
	_tmp66_ = bottom;
	_tmp67_ = top;
	_tmp68_.x = _tmp62_;
	_tmp68_.y = _tmp63_;
	_tmp68_.width = _tmp64_ - _tmp65_;
	_tmp68_.height = _tmp66_ - _tmp67_;
	_vala_extent = _tmp68_;
	_tmp69_ = surface;
	_tmp70_ = plank_drawing_dock_surface_new_with_internal (_tmp69_);
	result = _tmp70_;
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (surface);
	if (extent) {
		*extent = _vala_extent;
	}
	return result;
}


/**
 * Computes and returns the average color of the surface.
 *
 * @return the average color of the surface
 */
void plank_drawing_dock_surface_average_color (PlankDrawingDockSurface* self, PlankDrawingColor* result) {
	cairo_surface_t* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* _tmp4_ = NULL;
	PlankDrawingColor _tmp5_ = {0};
	PlankDrawingColor _tmp6_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_Internal;
	_tmp1_ = self->priv->_Width;
	_tmp2_ = self->priv->_Height;
	_tmp3_ = gdk_pixbuf_get_from_surface (_tmp0_, 0, 0, _tmp1_, _tmp2_);
	_tmp4_ = _tmp3_;
	plank_drawing_drawing_service_average_color (_tmp4_, &_tmp5_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp4_);
	*result = _tmp6_;
	return;
}


/**
 * Performs a fast blur on the surface.
 *
 * @param radius the radius of the blur
 * @param process_count how many iterations to blur
 */
void plank_drawing_dock_surface_fast_blur (PlankDrawingDockSurface* self, gint radius, gint process_count) {
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	gint w = 0;
	gint _tmp3_ = 0;
	gint h = 0;
	gint _tmp4_ = 0;
	gint channels = 0;
	gboolean _tmp5_ = FALSE;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	cairo_surface_t* original = NULL;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	cairo_surface_t* _tmp12_ = NULL;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp13_ = NULL;
	cairo_t* _tmp14_ = NULL;
	cairo_t* _tmp15_ = NULL;
	cairo_t* _tmp16_ = NULL;
	cairo_surface_t* _tmp17_ = NULL;
	cairo_t* _tmp18_ = NULL;
	guint8* pixels = NULL;
	cairo_surface_t* _tmp19_ = NULL;
	guchar* _tmp20_ = NULL;
	guint8* buffer = NULL;
	gint _tmp21_ = 0;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
	guint8* _tmp24_ = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	gint* vmin = NULL;
	gint _tmp25_ = 0;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	gint* _tmp28_ = NULL;
	gint vmin_length1 = 0;
	gint _vmin_size_ = 0;
	gint* vmax = NULL;
	gint _tmp29_ = 0;
	gint _tmp30_ = 0;
	gint _tmp31_ = 0;
	gint* _tmp32_ = NULL;
	gint vmax_length1 = 0;
	gint _vmax_size_ = 0;
	gint div = 0;
	gint _tmp33_ = 0;
	guint8* dv = NULL;
	gint _tmp34_ = 0;
	guint8* _tmp35_ = NULL;
	gint dv_length1 = 0;
	gint _dv_size_ = 0;
	cairo_surface_t* _tmp324_ = NULL;
	cairo_t* target_cr = NULL;
	cairo_t* _tmp325_ = NULL;
	cairo_t* _tmp326_ = NULL;
	cairo_t* _tmp327_ = NULL;
	cairo_t* _tmp328_ = NULL;
	cairo_surface_t* _tmp329_ = NULL;
	cairo_t* _tmp330_ = NULL;
	cairo_t* _tmp331_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp1_ = radius;
	if (_tmp1_ < 1) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp2_ = 0;
		_tmp2_ = process_count;
		_tmp0_ = _tmp2_ < 1;
	}
	if (_tmp0_) {
		return;
	}
	_tmp3_ = self->priv->_Width;
	w = _tmp3_;
	_tmp4_ = self->priv->_Height;
	h = _tmp4_;
	channels = 4;
	_tmp6_ = radius;
	_tmp7_ = w;
	if (_tmp6_ > (_tmp7_ - 1)) {
		_tmp5_ = TRUE;
	} else {
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		_tmp8_ = radius;
		_tmp9_ = h;
		_tmp5_ = _tmp8_ > (_tmp9_ - 1);
	}
	if (_tmp5_) {
		return;
	}
	_tmp10_ = w;
	_tmp11_ = h;
	_tmp12_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp10_, _tmp11_);
	original = _tmp12_;
	_tmp13_ = original;
	_tmp14_ = cairo_create (_tmp13_);
	cr = _tmp14_;
	_tmp15_ = cr;
	cairo_set_operator (_tmp15_, CAIRO_OPERATOR_SOURCE);
	_tmp16_ = cr;
	_tmp17_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp16_, _tmp17_, (gdouble) 0, (gdouble) 0);
	_tmp18_ = cr;
	cairo_paint (_tmp18_);
	_tmp19_ = original;
	_tmp20_ = cairo_image_surface_get_data (_tmp19_);
	pixels = _tmp20_;
	_tmp21_ = w;
	_tmp22_ = h;
	_tmp23_ = channels;
	_tmp24_ = g_new0 (guint8, (_tmp21_ * _tmp22_) * _tmp23_);
	buffer = _tmp24_;
	buffer_length1 = (_tmp21_ * _tmp22_) * _tmp23_;
	_buffer_size_ = buffer_length1;
	_tmp25_ = w;
	_tmp26_ = h;
	_tmp27_ = MAX (_tmp25_, _tmp26_);
	_tmp28_ = g_new0 (gint, _tmp27_);
	vmin = _tmp28_;
	vmin_length1 = _tmp27_;
	_vmin_size_ = vmin_length1;
	_tmp29_ = w;
	_tmp30_ = h;
	_tmp31_ = MAX (_tmp29_, _tmp30_);
	_tmp32_ = g_new0 (gint, _tmp31_);
	vmax = _tmp32_;
	vmax_length1 = _tmp31_;
	_vmax_size_ = vmax_length1;
	_tmp33_ = radius;
	div = (2 * _tmp33_) + 1;
	_tmp34_ = div;
	_tmp35_ = g_new0 (guint8, 256 * _tmp34_);
	dv = _tmp35_;
	dv_length1 = 256 * _tmp34_;
	_dv_size_ = dv_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp36_ = FALSE;
			_tmp36_ = TRUE;
			while (TRUE) {
				gint _tmp38_ = 0;
				guint8* _tmp39_ = NULL;
				gint _tmp39__length1 = 0;
				guint8* _tmp40_ = NULL;
				gint _tmp40__length1 = 0;
				gint _tmp41_ = 0;
				gint _tmp42_ = 0;
				gint _tmp43_ = 0;
				guint8 _tmp44_ = 0U;
				if (!_tmp36_) {
					gint _tmp37_ = 0;
					_tmp37_ = i;
					i = _tmp37_ + 1;
				}
				_tmp36_ = FALSE;
				_tmp38_ = i;
				_tmp39_ = dv;
				_tmp39__length1 = dv_length1;
				if (!(_tmp38_ < _tmp39__length1)) {
					break;
				}
				_tmp40_ = dv;
				_tmp40__length1 = dv_length1;
				_tmp41_ = i;
				_tmp42_ = i;
				_tmp43_ = div;
				_tmp40_[_tmp41_] = (guint8) (_tmp42_ / _tmp43_);
				_tmp44_ = _tmp40_[_tmp41_];
			}
		}
	}
	while (TRUE) {
		gint _tmp45_ = 0;
		_tmp45_ = process_count;
		process_count = _tmp45_ - 1;
		if (!(_tmp45_ > 0)) {
			break;
		}
		{
			gint x = 0;
			x = 0;
			{
				gboolean _tmp46_ = FALSE;
				_tmp46_ = TRUE;
				while (TRUE) {
					gint _tmp48_ = 0;
					gint _tmp49_ = 0;
					gint* _tmp50_ = NULL;
					gint _tmp50__length1 = 0;
					gint _tmp51_ = 0;
					gint _tmp52_ = 0;
					gint _tmp53_ = 0;
					gint _tmp54_ = 0;
					gint _tmp55_ = 0;
					gint _tmp56_ = 0;
					gint* _tmp57_ = NULL;
					gint _tmp57__length1 = 0;
					gint _tmp58_ = 0;
					gint _tmp59_ = 0;
					gint _tmp60_ = 0;
					gint _tmp61_ = 0;
					gint _tmp62_ = 0;
					if (!_tmp46_) {
						gint _tmp47_ = 0;
						_tmp47_ = x;
						x = _tmp47_ + 1;
					}
					_tmp46_ = FALSE;
					_tmp48_ = x;
					_tmp49_ = w;
					if (!(_tmp48_ < _tmp49_)) {
						break;
					}
					_tmp50_ = vmin;
					_tmp50__length1 = vmin_length1;
					_tmp51_ = x;
					_tmp52_ = x;
					_tmp53_ = radius;
					_tmp54_ = w;
					_tmp55_ = MIN ((_tmp52_ + _tmp53_) + 1, _tmp54_ - 1);
					_tmp50_[_tmp51_] = _tmp55_;
					_tmp56_ = _tmp50_[_tmp51_];
					_tmp57_ = vmax;
					_tmp57__length1 = vmax_length1;
					_tmp58_ = x;
					_tmp59_ = x;
					_tmp60_ = radius;
					_tmp61_ = MAX (_tmp59_ - _tmp60_, 0);
					_tmp57_[_tmp58_] = _tmp61_;
					_tmp62_ = _tmp57_[_tmp58_];
				}
			}
		}
		{
			gint y = 0;
			y = 0;
			{
				gboolean _tmp63_ = FALSE;
				_tmp63_ = TRUE;
				while (TRUE) {
					gint _tmp65_ = 0;
					gint _tmp66_ = 0;
					gint asum = 0;
					gint rsum = 0;
					gint gsum = 0;
					gint bsum = 0;
					guint32 cur_pixel = 0U;
					gint _tmp67_ = 0;
					gint _tmp68_ = 0;
					gint _tmp69_ = 0;
					gint _tmp70_ = 0;
					gint _tmp71_ = 0;
					guint8* _tmp72_ = NULL;
					guint32 _tmp73_ = 0U;
					guint8 _tmp74_ = 0U;
					gint _tmp75_ = 0;
					gint _tmp76_ = 0;
					guint8* _tmp77_ = NULL;
					guint32 _tmp78_ = 0U;
					guint8 _tmp79_ = 0U;
					gint _tmp80_ = 0;
					gint _tmp81_ = 0;
					guint8* _tmp82_ = NULL;
					guint32 _tmp83_ = 0U;
					guint8 _tmp84_ = 0U;
					gint _tmp85_ = 0;
					gint _tmp86_ = 0;
					guint8* _tmp87_ = NULL;
					guint32 _tmp88_ = 0U;
					guint8 _tmp89_ = 0U;
					gint _tmp112_ = 0;
					gint _tmp113_ = 0;
					gint _tmp114_ = 0;
					if (!_tmp63_) {
						gint _tmp64_ = 0;
						_tmp64_ = y;
						y = _tmp64_ + 1;
					}
					_tmp63_ = FALSE;
					_tmp65_ = y;
					_tmp66_ = h;
					if (!(_tmp65_ < _tmp66_)) {
						break;
					}
					asum = 0;
					rsum = 0;
					gsum = 0;
					bsum = 0;
					_tmp67_ = y;
					_tmp68_ = w;
					_tmp69_ = channels;
					cur_pixel = (guint32) ((_tmp67_ * _tmp68_) * _tmp69_);
					_tmp70_ = asum;
					_tmp71_ = radius;
					_tmp72_ = pixels;
					_tmp73_ = cur_pixel;
					_tmp74_ = _tmp72_[_tmp73_ + 0];
					asum = _tmp70_ + (_tmp71_ * _tmp74_);
					_tmp75_ = rsum;
					_tmp76_ = radius;
					_tmp77_ = pixels;
					_tmp78_ = cur_pixel;
					_tmp79_ = _tmp77_[_tmp78_ + 1];
					rsum = _tmp75_ + (_tmp76_ * _tmp79_);
					_tmp80_ = gsum;
					_tmp81_ = radius;
					_tmp82_ = pixels;
					_tmp83_ = cur_pixel;
					_tmp84_ = _tmp82_[_tmp83_ + 2];
					gsum = _tmp80_ + (_tmp81_ * _tmp84_);
					_tmp85_ = bsum;
					_tmp86_ = radius;
					_tmp87_ = pixels;
					_tmp88_ = cur_pixel;
					_tmp89_ = _tmp87_[_tmp88_ + 3];
					bsum = _tmp85_ + (_tmp86_ * _tmp89_);
					{
						gint i = 0;
						i = 0;
						{
							gboolean _tmp90_ = FALSE;
							_tmp90_ = TRUE;
							while (TRUE) {
								gint _tmp92_ = 0;
								gint _tmp93_ = 0;
								gint _tmp94_ = 0;
								guint8* _tmp95_ = NULL;
								guint32 _tmp96_ = 0U;
								guint8 _tmp97_ = 0U;
								gint _tmp98_ = 0;
								guint8* _tmp99_ = NULL;
								guint32 _tmp100_ = 0U;
								guint8 _tmp101_ = 0U;
								gint _tmp102_ = 0;
								guint8* _tmp103_ = NULL;
								guint32 _tmp104_ = 0U;
								guint8 _tmp105_ = 0U;
								gint _tmp106_ = 0;
								guint8* _tmp107_ = NULL;
								guint32 _tmp108_ = 0U;
								guint8 _tmp109_ = 0U;
								guint32 _tmp110_ = 0U;
								gint _tmp111_ = 0;
								if (!_tmp90_) {
									gint _tmp91_ = 0;
									_tmp91_ = i;
									i = _tmp91_ + 1;
								}
								_tmp90_ = FALSE;
								_tmp92_ = i;
								_tmp93_ = radius;
								if (!(_tmp92_ <= _tmp93_)) {
									break;
								}
								_tmp94_ = asum;
								_tmp95_ = pixels;
								_tmp96_ = cur_pixel;
								_tmp97_ = _tmp95_[_tmp96_ + 0];
								asum = _tmp94_ + _tmp97_;
								_tmp98_ = rsum;
								_tmp99_ = pixels;
								_tmp100_ = cur_pixel;
								_tmp101_ = _tmp99_[_tmp100_ + 1];
								rsum = _tmp98_ + _tmp101_;
								_tmp102_ = gsum;
								_tmp103_ = pixels;
								_tmp104_ = cur_pixel;
								_tmp105_ = _tmp103_[_tmp104_ + 2];
								gsum = _tmp102_ + _tmp105_;
								_tmp106_ = bsum;
								_tmp107_ = pixels;
								_tmp108_ = cur_pixel;
								_tmp109_ = _tmp107_[_tmp108_ + 3];
								bsum = _tmp106_ + _tmp109_;
								_tmp110_ = cur_pixel;
								_tmp111_ = channels;
								cur_pixel = _tmp110_ + _tmp111_;
							}
						}
					}
					_tmp112_ = y;
					_tmp113_ = w;
					_tmp114_ = channels;
					cur_pixel = (guint32) ((_tmp112_ * _tmp113_) * _tmp114_);
					{
						gint x = 0;
						x = 0;
						{
							gboolean _tmp115_ = FALSE;
							_tmp115_ = TRUE;
							while (TRUE) {
								gint _tmp117_ = 0;
								gint _tmp118_ = 0;
								guint32 p1 = 0U;
								gint _tmp119_ = 0;
								gint _tmp120_ = 0;
								gint* _tmp121_ = NULL;
								gint _tmp121__length1 = 0;
								gint _tmp122_ = 0;
								gint _tmp123_ = 0;
								gint _tmp124_ = 0;
								guint32 p2 = 0U;
								gint _tmp125_ = 0;
								gint _tmp126_ = 0;
								gint* _tmp127_ = NULL;
								gint _tmp127__length1 = 0;
								gint _tmp128_ = 0;
								gint _tmp129_ = 0;
								gint _tmp130_ = 0;
								guint8* _tmp131_ = NULL;
								gint _tmp131__length1 = 0;
								guint32 _tmp132_ = 0U;
								guint8* _tmp133_ = NULL;
								gint _tmp133__length1 = 0;
								gint _tmp134_ = 0;
								guint8 _tmp135_ = 0U;
								guint8 _tmp136_ = 0U;
								guint8* _tmp137_ = NULL;
								gint _tmp137__length1 = 0;
								guint32 _tmp138_ = 0U;
								guint8* _tmp139_ = NULL;
								gint _tmp139__length1 = 0;
								gint _tmp140_ = 0;
								guint8 _tmp141_ = 0U;
								guint8 _tmp142_ = 0U;
								guint8* _tmp143_ = NULL;
								gint _tmp143__length1 = 0;
								guint32 _tmp144_ = 0U;
								guint8* _tmp145_ = NULL;
								gint _tmp145__length1 = 0;
								gint _tmp146_ = 0;
								guint8 _tmp147_ = 0U;
								guint8 _tmp148_ = 0U;
								guint8* _tmp149_ = NULL;
								gint _tmp149__length1 = 0;
								guint32 _tmp150_ = 0U;
								guint8* _tmp151_ = NULL;
								gint _tmp151__length1 = 0;
								gint _tmp152_ = 0;
								guint8 _tmp153_ = 0U;
								guint8 _tmp154_ = 0U;
								gint _tmp155_ = 0;
								guint8* _tmp156_ = NULL;
								guint32 _tmp157_ = 0U;
								guint8 _tmp158_ = 0U;
								guint8* _tmp159_ = NULL;
								guint32 _tmp160_ = 0U;
								guint8 _tmp161_ = 0U;
								gint _tmp162_ = 0;
								guint8* _tmp163_ = NULL;
								guint32 _tmp164_ = 0U;
								guint8 _tmp165_ = 0U;
								guint8* _tmp166_ = NULL;
								guint32 _tmp167_ = 0U;
								guint8 _tmp168_ = 0U;
								gint _tmp169_ = 0;
								guint8* _tmp170_ = NULL;
								guint32 _tmp171_ = 0U;
								guint8 _tmp172_ = 0U;
								guint8* _tmp173_ = NULL;
								guint32 _tmp174_ = 0U;
								guint8 _tmp175_ = 0U;
								gint _tmp176_ = 0;
								guint8* _tmp177_ = NULL;
								guint32 _tmp178_ = 0U;
								guint8 _tmp179_ = 0U;
								guint8* _tmp180_ = NULL;
								guint32 _tmp181_ = 0U;
								guint8 _tmp182_ = 0U;
								guint32 _tmp183_ = 0U;
								gint _tmp184_ = 0;
								if (!_tmp115_) {
									gint _tmp116_ = 0;
									_tmp116_ = x;
									x = _tmp116_ + 1;
								}
								_tmp115_ = FALSE;
								_tmp117_ = x;
								_tmp118_ = w;
								if (!(_tmp117_ < _tmp118_)) {
									break;
								}
								_tmp119_ = y;
								_tmp120_ = w;
								_tmp121_ = vmin;
								_tmp121__length1 = vmin_length1;
								_tmp122_ = x;
								_tmp123_ = _tmp121_[_tmp122_];
								_tmp124_ = channels;
								p1 = (guint32) (((_tmp119_ * _tmp120_) + _tmp123_) * _tmp124_);
								_tmp125_ = y;
								_tmp126_ = w;
								_tmp127_ = vmax;
								_tmp127__length1 = vmax_length1;
								_tmp128_ = x;
								_tmp129_ = _tmp127_[_tmp128_];
								_tmp130_ = channels;
								p2 = (guint32) (((_tmp125_ * _tmp126_) + _tmp129_) * _tmp130_);
								_tmp131_ = buffer;
								_tmp131__length1 = buffer_length1;
								_tmp132_ = cur_pixel;
								_tmp133_ = dv;
								_tmp133__length1 = dv_length1;
								_tmp134_ = asum;
								_tmp135_ = _tmp133_[_tmp134_];
								_tmp131_[_tmp132_ + 0] = _tmp135_;
								_tmp136_ = _tmp131_[_tmp132_ + 0];
								_tmp137_ = buffer;
								_tmp137__length1 = buffer_length1;
								_tmp138_ = cur_pixel;
								_tmp139_ = dv;
								_tmp139__length1 = dv_length1;
								_tmp140_ = rsum;
								_tmp141_ = _tmp139_[_tmp140_];
								_tmp137_[_tmp138_ + 1] = _tmp141_;
								_tmp142_ = _tmp137_[_tmp138_ + 1];
								_tmp143_ = buffer;
								_tmp143__length1 = buffer_length1;
								_tmp144_ = cur_pixel;
								_tmp145_ = dv;
								_tmp145__length1 = dv_length1;
								_tmp146_ = gsum;
								_tmp147_ = _tmp145_[_tmp146_];
								_tmp143_[_tmp144_ + 2] = _tmp147_;
								_tmp148_ = _tmp143_[_tmp144_ + 2];
								_tmp149_ = buffer;
								_tmp149__length1 = buffer_length1;
								_tmp150_ = cur_pixel;
								_tmp151_ = dv;
								_tmp151__length1 = dv_length1;
								_tmp152_ = bsum;
								_tmp153_ = _tmp151_[_tmp152_];
								_tmp149_[_tmp150_ + 3] = _tmp153_;
								_tmp154_ = _tmp149_[_tmp150_ + 3];
								_tmp155_ = asum;
								_tmp156_ = pixels;
								_tmp157_ = p1;
								_tmp158_ = _tmp156_[_tmp157_ + 0];
								_tmp159_ = pixels;
								_tmp160_ = p2;
								_tmp161_ = _tmp159_[_tmp160_ + 0];
								asum = _tmp155_ + (_tmp158_ - _tmp161_);
								_tmp162_ = rsum;
								_tmp163_ = pixels;
								_tmp164_ = p1;
								_tmp165_ = _tmp163_[_tmp164_ + 1];
								_tmp166_ = pixels;
								_tmp167_ = p2;
								_tmp168_ = _tmp166_[_tmp167_ + 1];
								rsum = _tmp162_ + (_tmp165_ - _tmp168_);
								_tmp169_ = gsum;
								_tmp170_ = pixels;
								_tmp171_ = p1;
								_tmp172_ = _tmp170_[_tmp171_ + 2];
								_tmp173_ = pixels;
								_tmp174_ = p2;
								_tmp175_ = _tmp173_[_tmp174_ + 2];
								gsum = _tmp169_ + (_tmp172_ - _tmp175_);
								_tmp176_ = bsum;
								_tmp177_ = pixels;
								_tmp178_ = p1;
								_tmp179_ = _tmp177_[_tmp178_ + 3];
								_tmp180_ = pixels;
								_tmp181_ = p2;
								_tmp182_ = _tmp180_[_tmp181_ + 3];
								bsum = _tmp176_ + (_tmp179_ - _tmp182_);
								_tmp183_ = cur_pixel;
								_tmp184_ = channels;
								cur_pixel = _tmp183_ + _tmp184_;
							}
						}
					}
				}
			}
		}
		{
			gint y = 0;
			y = 0;
			{
				gboolean _tmp185_ = FALSE;
				_tmp185_ = TRUE;
				while (TRUE) {
					gint _tmp187_ = 0;
					gint _tmp188_ = 0;
					gint* _tmp189_ = NULL;
					gint _tmp189__length1 = 0;
					gint _tmp190_ = 0;
					gint _tmp191_ = 0;
					gint _tmp192_ = 0;
					gint _tmp193_ = 0;
					gint _tmp194_ = 0;
					gint _tmp195_ = 0;
					gint _tmp196_ = 0;
					gint* _tmp197_ = NULL;
					gint _tmp197__length1 = 0;
					gint _tmp198_ = 0;
					gint _tmp199_ = 0;
					gint _tmp200_ = 0;
					gint _tmp201_ = 0;
					gint _tmp202_ = 0;
					gint _tmp203_ = 0;
					if (!_tmp185_) {
						gint _tmp186_ = 0;
						_tmp186_ = y;
						y = _tmp186_ + 1;
					}
					_tmp185_ = FALSE;
					_tmp187_ = y;
					_tmp188_ = h;
					if (!(_tmp187_ < _tmp188_)) {
						break;
					}
					_tmp189_ = vmin;
					_tmp189__length1 = vmin_length1;
					_tmp190_ = y;
					_tmp191_ = y;
					_tmp192_ = radius;
					_tmp193_ = h;
					_tmp194_ = MIN ((_tmp191_ + _tmp192_) + 1, _tmp193_ - 1);
					_tmp195_ = w;
					_tmp189_[_tmp190_] = _tmp194_ * _tmp195_;
					_tmp196_ = _tmp189_[_tmp190_];
					_tmp197_ = vmax;
					_tmp197__length1 = vmax_length1;
					_tmp198_ = y;
					_tmp199_ = y;
					_tmp200_ = radius;
					_tmp201_ = MAX (_tmp199_ - _tmp200_, 0);
					_tmp202_ = w;
					_tmp197_[_tmp198_] = _tmp201_ * _tmp202_;
					_tmp203_ = _tmp197_[_tmp198_];
				}
			}
		}
		{
			gint x = 0;
			x = 0;
			{
				gboolean _tmp204_ = FALSE;
				_tmp204_ = TRUE;
				while (TRUE) {
					gint _tmp206_ = 0;
					gint _tmp207_ = 0;
					gint asum = 0;
					gint rsum = 0;
					gint gsum = 0;
					gint bsum = 0;
					guint32 cur_pixel = 0U;
					gint _tmp208_ = 0;
					gint _tmp209_ = 0;
					gint _tmp210_ = 0;
					gint _tmp211_ = 0;
					guint8* _tmp212_ = NULL;
					gint _tmp212__length1 = 0;
					guint32 _tmp213_ = 0U;
					guint8 _tmp214_ = 0U;
					gint _tmp215_ = 0;
					gint _tmp216_ = 0;
					guint8* _tmp217_ = NULL;
					gint _tmp217__length1 = 0;
					guint32 _tmp218_ = 0U;
					guint8 _tmp219_ = 0U;
					gint _tmp220_ = 0;
					gint _tmp221_ = 0;
					guint8* _tmp222_ = NULL;
					gint _tmp222__length1 = 0;
					guint32 _tmp223_ = 0U;
					guint8 _tmp224_ = 0U;
					gint _tmp225_ = 0;
					gint _tmp226_ = 0;
					guint8* _tmp227_ = NULL;
					gint _tmp227__length1 = 0;
					guint32 _tmp228_ = 0U;
					guint8 _tmp229_ = 0U;
					gint _tmp253_ = 0;
					gint _tmp254_ = 0;
					if (!_tmp204_) {
						gint _tmp205_ = 0;
						_tmp205_ = x;
						x = _tmp205_ + 1;
					}
					_tmp204_ = FALSE;
					_tmp206_ = x;
					_tmp207_ = w;
					if (!(_tmp206_ < _tmp207_)) {
						break;
					}
					asum = 0;
					rsum = 0;
					gsum = 0;
					bsum = 0;
					_tmp208_ = x;
					_tmp209_ = channels;
					cur_pixel = (guint32) (_tmp208_ * _tmp209_);
					_tmp210_ = asum;
					_tmp211_ = radius;
					_tmp212_ = buffer;
					_tmp212__length1 = buffer_length1;
					_tmp213_ = cur_pixel;
					_tmp214_ = _tmp212_[_tmp213_ + 0];
					asum = _tmp210_ + (_tmp211_ * _tmp214_);
					_tmp215_ = rsum;
					_tmp216_ = radius;
					_tmp217_ = buffer;
					_tmp217__length1 = buffer_length1;
					_tmp218_ = cur_pixel;
					_tmp219_ = _tmp217_[_tmp218_ + 1];
					rsum = _tmp215_ + (_tmp216_ * _tmp219_);
					_tmp220_ = gsum;
					_tmp221_ = radius;
					_tmp222_ = buffer;
					_tmp222__length1 = buffer_length1;
					_tmp223_ = cur_pixel;
					_tmp224_ = _tmp222_[_tmp223_ + 2];
					gsum = _tmp220_ + (_tmp221_ * _tmp224_);
					_tmp225_ = bsum;
					_tmp226_ = radius;
					_tmp227_ = buffer;
					_tmp227__length1 = buffer_length1;
					_tmp228_ = cur_pixel;
					_tmp229_ = _tmp227_[_tmp228_ + 3];
					bsum = _tmp225_ + (_tmp226_ * _tmp229_);
					{
						gint i = 0;
						i = 0;
						{
							gboolean _tmp230_ = FALSE;
							_tmp230_ = TRUE;
							while (TRUE) {
								gint _tmp232_ = 0;
								gint _tmp233_ = 0;
								gint _tmp234_ = 0;
								guint8* _tmp235_ = NULL;
								gint _tmp235__length1 = 0;
								guint32 _tmp236_ = 0U;
								guint8 _tmp237_ = 0U;
								gint _tmp238_ = 0;
								guint8* _tmp239_ = NULL;
								gint _tmp239__length1 = 0;
								guint32 _tmp240_ = 0U;
								guint8 _tmp241_ = 0U;
								gint _tmp242_ = 0;
								guint8* _tmp243_ = NULL;
								gint _tmp243__length1 = 0;
								guint32 _tmp244_ = 0U;
								guint8 _tmp245_ = 0U;
								gint _tmp246_ = 0;
								guint8* _tmp247_ = NULL;
								gint _tmp247__length1 = 0;
								guint32 _tmp248_ = 0U;
								guint8 _tmp249_ = 0U;
								guint32 _tmp250_ = 0U;
								gint _tmp251_ = 0;
								gint _tmp252_ = 0;
								if (!_tmp230_) {
									gint _tmp231_ = 0;
									_tmp231_ = i;
									i = _tmp231_ + 1;
								}
								_tmp230_ = FALSE;
								_tmp232_ = i;
								_tmp233_ = radius;
								if (!(_tmp232_ <= _tmp233_)) {
									break;
								}
								_tmp234_ = asum;
								_tmp235_ = buffer;
								_tmp235__length1 = buffer_length1;
								_tmp236_ = cur_pixel;
								_tmp237_ = _tmp235_[_tmp236_ + 0];
								asum = _tmp234_ + _tmp237_;
								_tmp238_ = rsum;
								_tmp239_ = buffer;
								_tmp239__length1 = buffer_length1;
								_tmp240_ = cur_pixel;
								_tmp241_ = _tmp239_[_tmp240_ + 1];
								rsum = _tmp238_ + _tmp241_;
								_tmp242_ = gsum;
								_tmp243_ = buffer;
								_tmp243__length1 = buffer_length1;
								_tmp244_ = cur_pixel;
								_tmp245_ = _tmp243_[_tmp244_ + 2];
								gsum = _tmp242_ + _tmp245_;
								_tmp246_ = bsum;
								_tmp247_ = buffer;
								_tmp247__length1 = buffer_length1;
								_tmp248_ = cur_pixel;
								_tmp249_ = _tmp247_[_tmp248_ + 3];
								bsum = _tmp246_ + _tmp249_;
								_tmp250_ = cur_pixel;
								_tmp251_ = w;
								_tmp252_ = channels;
								cur_pixel = _tmp250_ + (_tmp251_ * _tmp252_);
							}
						}
					}
					_tmp253_ = x;
					_tmp254_ = channels;
					cur_pixel = (guint32) (_tmp253_ * _tmp254_);
					{
						gint y = 0;
						y = 0;
						{
							gboolean _tmp255_ = FALSE;
							_tmp255_ = TRUE;
							while (TRUE) {
								gint _tmp257_ = 0;
								gint _tmp258_ = 0;
								guint32 p1 = 0U;
								gint _tmp259_ = 0;
								gint* _tmp260_ = NULL;
								gint _tmp260__length1 = 0;
								gint _tmp261_ = 0;
								gint _tmp262_ = 0;
								gint _tmp263_ = 0;
								guint32 p2 = 0U;
								gint _tmp264_ = 0;
								gint* _tmp265_ = NULL;
								gint _tmp265__length1 = 0;
								gint _tmp266_ = 0;
								gint _tmp267_ = 0;
								gint _tmp268_ = 0;
								guint8* _tmp269_ = NULL;
								guint32 _tmp270_ = 0U;
								guint8* _tmp271_ = NULL;
								gint _tmp271__length1 = 0;
								gint _tmp272_ = 0;
								guint8 _tmp273_ = 0U;
								guint8 _tmp274_ = 0U;
								guint8* _tmp275_ = NULL;
								guint32 _tmp276_ = 0U;
								guint8* _tmp277_ = NULL;
								gint _tmp277__length1 = 0;
								gint _tmp278_ = 0;
								guint8 _tmp279_ = 0U;
								guint8 _tmp280_ = 0U;
								guint8* _tmp281_ = NULL;
								guint32 _tmp282_ = 0U;
								guint8* _tmp283_ = NULL;
								gint _tmp283__length1 = 0;
								gint _tmp284_ = 0;
								guint8 _tmp285_ = 0U;
								guint8 _tmp286_ = 0U;
								guint8* _tmp287_ = NULL;
								guint32 _tmp288_ = 0U;
								guint8* _tmp289_ = NULL;
								gint _tmp289__length1 = 0;
								gint _tmp290_ = 0;
								guint8 _tmp291_ = 0U;
								guint8 _tmp292_ = 0U;
								gint _tmp293_ = 0;
								guint8* _tmp294_ = NULL;
								gint _tmp294__length1 = 0;
								guint32 _tmp295_ = 0U;
								guint8 _tmp296_ = 0U;
								guint8* _tmp297_ = NULL;
								gint _tmp297__length1 = 0;
								guint32 _tmp298_ = 0U;
								guint8 _tmp299_ = 0U;
								gint _tmp300_ = 0;
								guint8* _tmp301_ = NULL;
								gint _tmp301__length1 = 0;
								guint32 _tmp302_ = 0U;
								guint8 _tmp303_ = 0U;
								guint8* _tmp304_ = NULL;
								gint _tmp304__length1 = 0;
								guint32 _tmp305_ = 0U;
								guint8 _tmp306_ = 0U;
								gint _tmp307_ = 0;
								guint8* _tmp308_ = NULL;
								gint _tmp308__length1 = 0;
								guint32 _tmp309_ = 0U;
								guint8 _tmp310_ = 0U;
								guint8* _tmp311_ = NULL;
								gint _tmp311__length1 = 0;
								guint32 _tmp312_ = 0U;
								guint8 _tmp313_ = 0U;
								gint _tmp314_ = 0;
								guint8* _tmp315_ = NULL;
								gint _tmp315__length1 = 0;
								guint32 _tmp316_ = 0U;
								guint8 _tmp317_ = 0U;
								guint8* _tmp318_ = NULL;
								gint _tmp318__length1 = 0;
								guint32 _tmp319_ = 0U;
								guint8 _tmp320_ = 0U;
								guint32 _tmp321_ = 0U;
								gint _tmp322_ = 0;
								gint _tmp323_ = 0;
								if (!_tmp255_) {
									gint _tmp256_ = 0;
									_tmp256_ = y;
									y = _tmp256_ + 1;
								}
								_tmp255_ = FALSE;
								_tmp257_ = y;
								_tmp258_ = h;
								if (!(_tmp257_ < _tmp258_)) {
									break;
								}
								_tmp259_ = x;
								_tmp260_ = vmin;
								_tmp260__length1 = vmin_length1;
								_tmp261_ = y;
								_tmp262_ = _tmp260_[_tmp261_];
								_tmp263_ = channels;
								p1 = (guint32) ((_tmp259_ + _tmp262_) * _tmp263_);
								_tmp264_ = x;
								_tmp265_ = vmax;
								_tmp265__length1 = vmax_length1;
								_tmp266_ = y;
								_tmp267_ = _tmp265_[_tmp266_];
								_tmp268_ = channels;
								p2 = (guint32) ((_tmp264_ + _tmp267_) * _tmp268_);
								_tmp269_ = pixels;
								_tmp270_ = cur_pixel;
								_tmp271_ = dv;
								_tmp271__length1 = dv_length1;
								_tmp272_ = asum;
								_tmp273_ = _tmp271_[_tmp272_];
								_tmp269_[_tmp270_ + 0] = _tmp273_;
								_tmp274_ = _tmp269_[_tmp270_ + 0];
								_tmp275_ = pixels;
								_tmp276_ = cur_pixel;
								_tmp277_ = dv;
								_tmp277__length1 = dv_length1;
								_tmp278_ = rsum;
								_tmp279_ = _tmp277_[_tmp278_];
								_tmp275_[_tmp276_ + 1] = _tmp279_;
								_tmp280_ = _tmp275_[_tmp276_ + 1];
								_tmp281_ = pixels;
								_tmp282_ = cur_pixel;
								_tmp283_ = dv;
								_tmp283__length1 = dv_length1;
								_tmp284_ = gsum;
								_tmp285_ = _tmp283_[_tmp284_];
								_tmp281_[_tmp282_ + 2] = _tmp285_;
								_tmp286_ = _tmp281_[_tmp282_ + 2];
								_tmp287_ = pixels;
								_tmp288_ = cur_pixel;
								_tmp289_ = dv;
								_tmp289__length1 = dv_length1;
								_tmp290_ = bsum;
								_tmp291_ = _tmp289_[_tmp290_];
								_tmp287_[_tmp288_ + 3] = _tmp291_;
								_tmp292_ = _tmp287_[_tmp288_ + 3];
								_tmp293_ = asum;
								_tmp294_ = buffer;
								_tmp294__length1 = buffer_length1;
								_tmp295_ = p1;
								_tmp296_ = _tmp294_[_tmp295_ + 0];
								_tmp297_ = buffer;
								_tmp297__length1 = buffer_length1;
								_tmp298_ = p2;
								_tmp299_ = _tmp297_[_tmp298_ + 0];
								asum = _tmp293_ + (_tmp296_ - _tmp299_);
								_tmp300_ = rsum;
								_tmp301_ = buffer;
								_tmp301__length1 = buffer_length1;
								_tmp302_ = p1;
								_tmp303_ = _tmp301_[_tmp302_ + 1];
								_tmp304_ = buffer;
								_tmp304__length1 = buffer_length1;
								_tmp305_ = p2;
								_tmp306_ = _tmp304_[_tmp305_ + 1];
								rsum = _tmp300_ + (_tmp303_ - _tmp306_);
								_tmp307_ = gsum;
								_tmp308_ = buffer;
								_tmp308__length1 = buffer_length1;
								_tmp309_ = p1;
								_tmp310_ = _tmp308_[_tmp309_ + 2];
								_tmp311_ = buffer;
								_tmp311__length1 = buffer_length1;
								_tmp312_ = p2;
								_tmp313_ = _tmp311_[_tmp312_ + 2];
								gsum = _tmp307_ + (_tmp310_ - _tmp313_);
								_tmp314_ = bsum;
								_tmp315_ = buffer;
								_tmp315__length1 = buffer_length1;
								_tmp316_ = p1;
								_tmp317_ = _tmp315_[_tmp316_ + 3];
								_tmp318_ = buffer;
								_tmp318__length1 = buffer_length1;
								_tmp319_ = p2;
								_tmp320_ = _tmp318_[_tmp319_ + 3];
								bsum = _tmp314_ + (_tmp317_ - _tmp320_);
								_tmp321_ = cur_pixel;
								_tmp322_ = w;
								_tmp323_ = channels;
								cur_pixel = _tmp321_ + (_tmp322_ * _tmp323_);
							}
						}
					}
				}
			}
		}
	}
	_tmp324_ = original;
	cairo_surface_mark_dirty (_tmp324_);
	_tmp325_ = self->priv->_Context;
	target_cr = _tmp325_;
	_tmp326_ = target_cr;
	cairo_save (_tmp326_);
	_tmp327_ = target_cr;
	cairo_set_operator (_tmp327_, CAIRO_OPERATOR_SOURCE);
	_tmp328_ = target_cr;
	_tmp329_ = original;
	cairo_set_source_surface (_tmp328_, _tmp329_, (gdouble) 0, (gdouble) 0);
	_tmp330_ = target_cr;
	cairo_paint (_tmp330_);
	_tmp331_ = target_cr;
	cairo_restore (_tmp331_);
	dv = (g_free (dv), NULL);
	vmax = (g_free (vmax), NULL);
	vmin = (g_free (vmin), NULL);
	buffer = (g_free (buffer), NULL);
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (original);
}


/**
 * Performs an exponential blur on the surface.
 *
 * @param radius the radius of the blur
 */
static Block4Data* block4_data_ref (Block4Data* _data4_) {
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}


static void block4_data_unref (void * _userdata_) {
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		PlankDrawingDockSurface* self;
		self = _data4_->self;
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}


static void* __lambda4_ (Block4Data* _data4_) {
	PlankDrawingDockSurface* self;
	void* result = NULL;
	guint8* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	self = _data4_->self;
	_tmp0_ = _data4_->pixels;
	_tmp1_ = _data4_->width;
	_tmp2_ = _data4_->height;
	_tmp3_ = _data4_->height;
	_tmp4_ = _data4_->width;
	_tmp5_ = _data4_->alpha;
	plank_drawing_dock_surface_exponential_blur_rows (self, _tmp0_, _tmp1_, _tmp2_, 0, _tmp3_ / 2, 0, _tmp4_, _tmp5_);
	result = NULL;
	return result;
}


static gpointer ___lambda4__gthread_func (gpointer self) {
	gpointer result;
	result = __lambda4_ (self);
	block4_data_unref (self);
	return result;
}


static gpointer _g_thread_ref0 (gpointer self) {
	return self ? g_thread_ref (self) : NULL;
}


static void* __lambda5_ (Block4Data* _data4_) {
	PlankDrawingDockSurface* self;
	void* result = NULL;
	guint8* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	self = _data4_->self;
	_tmp0_ = _data4_->pixels;
	_tmp1_ = _data4_->width;
	_tmp2_ = _data4_->height;
	_tmp3_ = _data4_->width;
	_tmp4_ = _data4_->height;
	_tmp5_ = _data4_->alpha;
	plank_drawing_dock_surface_exponential_blur_columns (self, _tmp0_, _tmp1_, _tmp2_, 0, _tmp3_ / 2, 0, _tmp4_, _tmp5_);
	result = NULL;
	return result;
}


static gpointer ___lambda5__gthread_func (gpointer self) {
	gpointer result;
	result = __lambda5_ (self);
	block4_data_unref (self);
	return result;
}


void plank_drawing_dock_surface_exponential_blur (PlankDrawingDockSurface* self, gint radius) {
	Block4Data* _data4_;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gdouble _tmp2_ = 0.0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	cairo_surface_t* original = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	cairo_surface_t* _tmp7_ = NULL;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp8_ = NULL;
	cairo_t* _tmp9_ = NULL;
	cairo_t* _tmp10_ = NULL;
	cairo_t* _tmp11_ = NULL;
	cairo_surface_t* _tmp12_ = NULL;
	cairo_t* _tmp13_ = NULL;
	cairo_surface_t* _tmp14_ = NULL;
	guchar* _tmp15_ = NULL;
	GThread* th = NULL;
	GThread* _tmp16_ = NULL;
	guint8* _tmp17_ = NULL;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	gint _tmp20_ = 0;
	gint _tmp21_ = 0;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
	GThread* _tmp24_ = NULL;
	GThread* _tmp25_ = NULL;
	GThread* th2 = NULL;
	GThread* _tmp26_ = NULL;
	guint8* _tmp27_ = NULL;
	gint _tmp28_ = 0;
	gint _tmp29_ = 0;
	gint _tmp30_ = 0;
	gint _tmp31_ = 0;
	gint _tmp32_ = 0;
	gint _tmp33_ = 0;
	GThread* _tmp34_ = NULL;
	GThread* _tmp35_ = NULL;
	cairo_surface_t* _tmp36_ = NULL;
	cairo_t* target_cr = NULL;
	cairo_t* _tmp37_ = NULL;
	cairo_t* _tmp38_ = NULL;
	cairo_t* _tmp39_ = NULL;
	cairo_t* _tmp40_ = NULL;
	cairo_surface_t* _tmp41_ = NULL;
	cairo_t* _tmp42_ = NULL;
	cairo_t* _tmp43_ = NULL;
	g_return_if_fail (self != NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = radius;
	if (_tmp0_ < 1) {
		block4_data_unref (_data4_);
		_data4_ = NULL;
		return;
	}
	_tmp1_ = radius;
	_tmp2_ = exp ((-2.3) / (_tmp1_ + 1.0));
	_data4_->alpha = (gint) ((1 << PLANK_DRAWING_DOCK_SURFACE_AlphaPrecision) * (1.0 - _tmp2_));
	_tmp3_ = self->priv->_Height;
	_data4_->height = _tmp3_;
	_tmp4_ = self->priv->_Width;
	_data4_->width = _tmp4_;
	_tmp5_ = _data4_->width;
	_tmp6_ = _data4_->height;
	_tmp7_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp5_, _tmp6_);
	original = _tmp7_;
	_tmp8_ = original;
	_tmp9_ = cairo_create (_tmp8_);
	cr = _tmp9_;
	_tmp10_ = cr;
	cairo_set_operator (_tmp10_, CAIRO_OPERATOR_SOURCE);
	_tmp11_ = cr;
	_tmp12_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp11_, _tmp12_, (gdouble) 0, (gdouble) 0);
	_tmp13_ = cr;
	cairo_paint (_tmp13_);
	_tmp14_ = original;
	_tmp15_ = cairo_image_surface_get_data (_tmp14_);
	_data4_->pixels = _tmp15_;
	_tmp16_ = g_thread_new (NULL, ___lambda4__gthread_func, block4_data_ref (_data4_));
	th = _tmp16_;
	_tmp17_ = _data4_->pixels;
	_tmp18_ = _data4_->width;
	_tmp19_ = _data4_->height;
	_tmp20_ = _data4_->height;
	_tmp21_ = _data4_->height;
	_tmp22_ = _data4_->width;
	_tmp23_ = _data4_->alpha;
	plank_drawing_dock_surface_exponential_blur_rows (self, _tmp17_, _tmp18_, _tmp19_, _tmp20_ / 2, _tmp21_, 0, _tmp22_, _tmp23_);
	_tmp24_ = th;
	_tmp25_ = _g_thread_ref0 (_tmp24_);
	g_thread_join (_tmp25_);
	_tmp26_ = g_thread_new (NULL, ___lambda5__gthread_func, block4_data_ref (_data4_));
	th2 = _tmp26_;
	_tmp27_ = _data4_->pixels;
	_tmp28_ = _data4_->width;
	_tmp29_ = _data4_->height;
	_tmp30_ = _data4_->width;
	_tmp31_ = _data4_->width;
	_tmp32_ = _data4_->height;
	_tmp33_ = _data4_->alpha;
	plank_drawing_dock_surface_exponential_blur_columns (self, _tmp27_, _tmp28_, _tmp29_, _tmp30_ / 2, _tmp31_, 0, _tmp32_, _tmp33_);
	_tmp34_ = th2;
	_tmp35_ = _g_thread_ref0 (_tmp34_);
	g_thread_join (_tmp35_);
	_tmp36_ = original;
	cairo_surface_mark_dirty (_tmp36_);
	_tmp37_ = self->priv->_Context;
	target_cr = _tmp37_;
	_tmp38_ = target_cr;
	cairo_save (_tmp38_);
	_tmp39_ = target_cr;
	cairo_set_operator (_tmp39_, CAIRO_OPERATOR_SOURCE);
	_tmp40_ = target_cr;
	_tmp41_ = original;
	cairo_set_source_surface (_tmp40_, _tmp41_, (gdouble) 0, (gdouble) 0);
	_tmp42_ = target_cr;
	cairo_paint (_tmp42_);
	_tmp43_ = target_cr;
	cairo_restore (_tmp43_);
	_g_thread_unref0 (th2);
	_g_thread_unref0 (th);
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (original);
	block4_data_unref (_data4_);
	_data4_ = NULL;
}


static void plank_drawing_dock_surface_exponential_blur_columns (PlankDrawingDockSurface* self, guint8* pixels, gint width, gint height, gint startCol, gint endCol, gint startY, gint endY, gint alpha) {
	g_return_if_fail (self != NULL);
	{
		gint columnIndex = 0;
		gint _tmp0_ = 0;
		_tmp0_ = startCol;
		columnIndex = _tmp0_;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_ = 0;
				gint _tmp4_ = 0;
				guint8* column = NULL;
				guint8* _tmp5_ = NULL;
				gint _tmp6_ = 0;
				gint zA = 0;
				guint8* _tmp7_ = NULL;
				guint8 _tmp8_ = 0U;
				gint zR = 0;
				guint8* _tmp9_ = NULL;
				guint8 _tmp10_ = 0U;
				gint zG = 0;
				guint8* _tmp11_ = NULL;
				guint8 _tmp12_ = 0U;
				gint zB = 0;
				guint8* _tmp13_ = NULL;
				guint8 _tmp14_ = 0U;
				if (!_tmp1_) {
					gint _tmp2_ = 0;
					_tmp2_ = columnIndex;
					columnIndex = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = columnIndex;
				_tmp4_ = endCol;
				if (!(_tmp3_ < _tmp4_)) {
					break;
				}
				_tmp5_ = pixels;
				_tmp6_ = columnIndex;
				column = _tmp5_ + (_tmp6_ * 4);
				_tmp7_ = column;
				_tmp8_ = _tmp7_[0];
				zA = _tmp8_ << PLANK_DRAWING_DOCK_SURFACE_ParamPrecision;
				_tmp9_ = column;
				_tmp10_ = _tmp9_[1];
				zR = _tmp10_ << PLANK_DRAWING_DOCK_SURFACE_ParamPrecision;
				_tmp11_ = column;
				_tmp12_ = _tmp11_[2];
				zG = _tmp12_ << PLANK_DRAWING_DOCK_SURFACE_ParamPrecision;
				_tmp13_ = column;
				_tmp14_ = _tmp13_[3];
				zB = _tmp14_ << PLANK_DRAWING_DOCK_SURFACE_ParamPrecision;
				{
					gint index = 0;
					gint _tmp15_ = 0;
					gint _tmp16_ = 0;
					_tmp15_ = width;
					_tmp16_ = startY;
					index = _tmp15_ * (_tmp16_ + 1);
					{
						gboolean _tmp17_ = FALSE;
						_tmp17_ = TRUE;
						while (TRUE) {
							gint _tmp20_ = 0;
							gint _tmp21_ = 0;
							gint _tmp22_ = 0;
							guint8* _tmp23_ = NULL;
							gint _tmp24_ = 0;
							gint _tmp25_ = 0;
							if (!_tmp17_) {
								gint _tmp18_ = 0;
								gint _tmp19_ = 0;
								_tmp18_ = index;
								_tmp19_ = width;
								index = _tmp18_ + _tmp19_;
							}
							_tmp17_ = FALSE;
							_tmp20_ = index;
							_tmp21_ = endY;
							_tmp22_ = width;
							if (!(_tmp20_ < ((_tmp21_ - 1) * _tmp22_))) {
								break;
							}
							_tmp23_ = column;
							_tmp24_ = index;
							_tmp25_ = alpha;
							plank_drawing_dock_surface_exponential_blur_inner (&_tmp23_[_tmp24_ * 4], &zA, &zR, &zG, &zB, _tmp25_);
						}
					}
				}
				{
					gint index = 0;
					gint _tmp26_ = 0;
					gint _tmp27_ = 0;
					_tmp26_ = endY;
					_tmp27_ = width;
					index = (_tmp26_ - 2) * _tmp27_;
					{
						gboolean _tmp28_ = FALSE;
						_tmp28_ = TRUE;
						while (TRUE) {
							gint _tmp31_ = 0;
							gint _tmp32_ = 0;
							guint8* _tmp33_ = NULL;
							gint _tmp34_ = 0;
							gint _tmp35_ = 0;
							if (!_tmp28_) {
								gint _tmp29_ = 0;
								gint _tmp30_ = 0;
								_tmp29_ = index;
								_tmp30_ = width;
								index = _tmp29_ - _tmp30_;
							}
							_tmp28_ = FALSE;
							_tmp31_ = index;
							_tmp32_ = startY;
							if (!(_tmp31_ >= _tmp32_)) {
								break;
							}
							_tmp33_ = column;
							_tmp34_ = index;
							_tmp35_ = alpha;
							plank_drawing_dock_surface_exponential_blur_inner (&_tmp33_[_tmp34_ * 4], &zA, &zR, &zG, &zB, _tmp35_);
						}
					}
				}
			}
		}
	}
}


static void plank_drawing_dock_surface_exponential_blur_rows (PlankDrawingDockSurface* self, guint8* pixels, gint width, gint height, gint startRow, gint endRow, gint startX, gint endX, gint alpha) {
	g_return_if_fail (self != NULL);
	{
		gint rowIndex = 0;
		gint _tmp0_ = 0;
		_tmp0_ = startRow;
		rowIndex = _tmp0_;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_ = 0;
				gint _tmp4_ = 0;
				guint8* row = NULL;
				guint8* _tmp5_ = NULL;
				gint _tmp6_ = 0;
				gint _tmp7_ = 0;
				gint zA = 0;
				guint8* _tmp8_ = NULL;
				gint _tmp9_ = 0;
				guint8 _tmp10_ = 0U;
				gint zR = 0;
				guint8* _tmp11_ = NULL;
				gint _tmp12_ = 0;
				guint8 _tmp13_ = 0U;
				gint zG = 0;
				guint8* _tmp14_ = NULL;
				gint _tmp15_ = 0;
				guint8 _tmp16_ = 0U;
				gint zB = 0;
				guint8* _tmp17_ = NULL;
				gint _tmp18_ = 0;
				guint8 _tmp19_ = 0U;
				if (!_tmp1_) {
					gint _tmp2_ = 0;
					_tmp2_ = rowIndex;
					rowIndex = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = rowIndex;
				_tmp4_ = endRow;
				if (!(_tmp3_ < _tmp4_)) {
					break;
				}
				_tmp5_ = pixels;
				_tmp6_ = rowIndex;
				_tmp7_ = width;
				row = _tmp5_ + ((_tmp6_ * _tmp7_) * 4);
				_tmp8_ = row;
				_tmp9_ = startX;
				_tmp10_ = _tmp8_[_tmp9_ + 0];
				zA = _tmp10_ << PLANK_DRAWING_DOCK_SURFACE_ParamPrecision;
				_tmp11_ = row;
				_tmp12_ = startX;
				_tmp13_ = _tmp11_[_tmp12_ + 1];
				zR = _tmp13_ << PLANK_DRAWING_DOCK_SURFACE_ParamPrecision;
				_tmp14_ = row;
				_tmp15_ = startX;
				_tmp16_ = _tmp14_[_tmp15_ + 2];
				zG = _tmp16_ << PLANK_DRAWING_DOCK_SURFACE_ParamPrecision;
				_tmp17_ = row;
				_tmp18_ = startX;
				_tmp19_ = _tmp17_[_tmp18_ + 3];
				zB = _tmp19_ << PLANK_DRAWING_DOCK_SURFACE_ParamPrecision;
				{
					gint index = 0;
					gint _tmp20_ = 0;
					_tmp20_ = startX;
					index = _tmp20_ + 1;
					{
						gboolean _tmp21_ = FALSE;
						_tmp21_ = TRUE;
						while (TRUE) {
							gint _tmp23_ = 0;
							gint _tmp24_ = 0;
							guint8* _tmp25_ = NULL;
							gint _tmp26_ = 0;
							gint _tmp27_ = 0;
							if (!_tmp21_) {
								gint _tmp22_ = 0;
								_tmp22_ = index;
								index = _tmp22_ + 1;
							}
							_tmp21_ = FALSE;
							_tmp23_ = index;
							_tmp24_ = endX;
							if (!(_tmp23_ < _tmp24_)) {
								break;
							}
							_tmp25_ = row;
							_tmp26_ = index;
							_tmp27_ = alpha;
							plank_drawing_dock_surface_exponential_blur_inner (&_tmp25_[_tmp26_ * 4], &zA, &zR, &zG, &zB, _tmp27_);
						}
					}
				}
				{
					gint index = 0;
					gint _tmp28_ = 0;
					_tmp28_ = endX;
					index = _tmp28_ - 2;
					{
						gboolean _tmp29_ = FALSE;
						_tmp29_ = TRUE;
						while (TRUE) {
							gint _tmp31_ = 0;
							gint _tmp32_ = 0;
							guint8* _tmp33_ = NULL;
							gint _tmp34_ = 0;
							gint _tmp35_ = 0;
							if (!_tmp29_) {
								gint _tmp30_ = 0;
								_tmp30_ = index;
								index = _tmp30_ - 1;
							}
							_tmp29_ = FALSE;
							_tmp31_ = index;
							_tmp32_ = startX;
							if (!(_tmp31_ >= _tmp32_)) {
								break;
							}
							_tmp33_ = row;
							_tmp34_ = index;
							_tmp35_ = alpha;
							plank_drawing_dock_surface_exponential_blur_inner (&_tmp33_[_tmp34_ * 4], &zA, &zR, &zG, &zB, _tmp35_);
						}
					}
				}
			}
		}
	}
}


static inline void plank_drawing_dock_surface_exponential_blur_inner (guint8* pixel, gint* zA, gint* zR, gint* zG, gint* zB, gint alpha) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	guint8* _tmp2_ = NULL;
	guint8 _tmp3_ = 0U;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	guint8* _tmp7_ = NULL;
	guint8 _tmp8_ = 0U;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	guint8* _tmp12_ = NULL;
	guint8 _tmp13_ = 0U;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	guint8* _tmp17_ = NULL;
	guint8 _tmp18_ = 0U;
	gint _tmp19_ = 0;
	guint8* _tmp20_ = NULL;
	gint _tmp21_ = 0;
	guint8 _tmp22_ = 0U;
	guint8* _tmp23_ = NULL;
	gint _tmp24_ = 0;
	guint8 _tmp25_ = 0U;
	guint8* _tmp26_ = NULL;
	gint _tmp27_ = 0;
	guint8 _tmp28_ = 0U;
	guint8* _tmp29_ = NULL;
	gint _tmp30_ = 0;
	guint8 _tmp31_ = 0U;
	_tmp0_ = *zA;
	_tmp1_ = alpha;
	_tmp2_ = pixel;
	_tmp3_ = _tmp2_[0];
	_tmp4_ = *zA;
	*zA = _tmp0_ + ((_tmp1_ * ((_tmp3_ << PLANK_DRAWING_DOCK_SURFACE_ParamPrecision) - _tmp4_)) >> PLANK_DRAWING_DOCK_SURFACE_AlphaPrecision);
	_tmp5_ = *zR;
	_tmp6_ = alpha;
	_tmp7_ = pixel;
	_tmp8_ = _tmp7_[1];
	_tmp9_ = *zR;
	*zR = _tmp5_ + ((_tmp6_ * ((_tmp8_ << PLANK_DRAWING_DOCK_SURFACE_ParamPrecision) - _tmp9_)) >> PLANK_DRAWING_DOCK_SURFACE_AlphaPrecision);
	_tmp10_ = *zG;
	_tmp11_ = alpha;
	_tmp12_ = pixel;
	_tmp13_ = _tmp12_[2];
	_tmp14_ = *zG;
	*zG = _tmp10_ + ((_tmp11_ * ((_tmp13_ << PLANK_DRAWING_DOCK_SURFACE_ParamPrecision) - _tmp14_)) >> PLANK_DRAWING_DOCK_SURFACE_AlphaPrecision);
	_tmp15_ = *zB;
	_tmp16_ = alpha;
	_tmp17_ = pixel;
	_tmp18_ = _tmp17_[3];
	_tmp19_ = *zB;
	*zB = _tmp15_ + ((_tmp16_ * ((_tmp18_ << PLANK_DRAWING_DOCK_SURFACE_ParamPrecision) - _tmp19_)) >> PLANK_DRAWING_DOCK_SURFACE_AlphaPrecision);
	_tmp20_ = pixel;
	_tmp21_ = *zA;
	_tmp20_[0] = (guint8) (_tmp21_ >> PLANK_DRAWING_DOCK_SURFACE_ParamPrecision);
	_tmp22_ = _tmp20_[0];
	_tmp23_ = pixel;
	_tmp24_ = *zR;
	_tmp23_[1] = (guint8) (_tmp24_ >> PLANK_DRAWING_DOCK_SURFACE_ParamPrecision);
	_tmp25_ = _tmp23_[1];
	_tmp26_ = pixel;
	_tmp27_ = *zG;
	_tmp26_[2] = (guint8) (_tmp27_ >> PLANK_DRAWING_DOCK_SURFACE_ParamPrecision);
	_tmp28_ = _tmp26_[2];
	_tmp29_ = pixel;
	_tmp30_ = *zB;
	_tmp29_[3] = (guint8) (_tmp30_ >> PLANK_DRAWING_DOCK_SURFACE_ParamPrecision);
	_tmp31_ = _tmp29_[3];
}


/**
 * Performs a gaussian blur on the surface.
 * ''Note: This method is wickedly slow''
 *
 * @param radius the radius of the blur
 */
static Block5Data* block5_data_ref (Block5Data* _data5_) {
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void block5_data_unref (void * _userdata_) {
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		PlankDrawingDockSurface* self;
		self = _data5_->self;
		_data5_->shiftar = (g_free (_data5_->shiftar), NULL);
		_data5_->bbuffer = (g_free (_data5_->bbuffer), NULL);
		_data5_->abuffer = (g_free (_data5_->abuffer), NULL);
		_data5_->kernel = (g_free (_data5_->kernel), NULL);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}


static void* __lambda6_ (Block5Data* _data5_) {
	PlankDrawingDockSurface* self;
	void* result = NULL;
	gdouble* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gdouble* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gdouble* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	gint _tmp7__length2 = 0;
	self = _data5_->self;
	_tmp0_ = _data5_->abuffer;
	_tmp0__length1 = _data5_->abuffer_length1;
	_tmp1_ = _data5_->bbuffer;
	_tmp1__length1 = _data5_->bbuffer_length1;
	_tmp2_ = _data5_->kernel;
	_tmp2__length1 = _data5_->kernel_length1;
	_tmp3_ = _data5_->gaussWidth;
	_tmp4_ = _data5_->width;
	_tmp5_ = _data5_->height;
	_tmp6_ = _data5_->height;
	_tmp7_ = _data5_->shiftar;
	_tmp7__length1 = _data5_->shiftar_length1;
	_tmp7__length2 = _data5_->shiftar_length2;
	plank_drawing_dock_surface_gaussian_blur_horizontal (self, _tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_, 0, _tmp6_ / 2, _tmp7_, _tmp7__length1, _tmp7__length2);
	result = NULL;
	return result;
}


static gpointer ___lambda6__gthread_func (gpointer self) {
	gpointer result;
	result = __lambda6_ (self);
	block5_data_unref (self);
	return result;
}


static void* __lambda7_ (Block5Data* _data5_) {
	PlankDrawingDockSurface* self;
	void* result = NULL;
	gdouble* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gdouble* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gdouble* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	gint _tmp7__length2 = 0;
	self = _data5_->self;
	_tmp0_ = _data5_->bbuffer;
	_tmp0__length1 = _data5_->bbuffer_length1;
	_tmp1_ = _data5_->abuffer;
	_tmp1__length1 = _data5_->abuffer_length1;
	_tmp2_ = _data5_->kernel;
	_tmp2__length1 = _data5_->kernel_length1;
	_tmp3_ = _data5_->gaussWidth;
	_tmp4_ = _data5_->width;
	_tmp5_ = _data5_->height;
	_tmp6_ = _data5_->width;
	_tmp7_ = _data5_->shiftar;
	_tmp7__length1 = _data5_->shiftar_length1;
	_tmp7__length2 = _data5_->shiftar_length2;
	plank_drawing_dock_surface_gaussian_blur_vertical (self, _tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_, 0, _tmp6_ / 2, _tmp7_, _tmp7__length1, _tmp7__length2);
	result = NULL;
	return result;
}


static gpointer ___lambda7__gthread_func (gpointer self) {
	gpointer result;
	result = __lambda7_ (self);
	block5_data_unref (self);
	return result;
}


void plank_drawing_dock_surface_gaussian_blur (PlankDrawingDockSurface* self, gint radius) {
	Block5Data* _data5_;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gdouble* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	cairo_surface_t* original = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	cairo_surface_t* _tmp9_ = NULL;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp10_ = NULL;
	cairo_t* _tmp11_ = NULL;
	cairo_t* _tmp12_ = NULL;
	cairo_t* _tmp13_ = NULL;
	cairo_surface_t* _tmp14_ = NULL;
	cairo_t* _tmp15_ = NULL;
	guint8* src = NULL;
	cairo_surface_t* _tmp16_ = NULL;
	guchar* _tmp17_ = NULL;
	gint size = 0;
	gint _tmp18_ = 0;
	cairo_surface_t* _tmp19_ = NULL;
	gint _tmp20_ = 0;
	gint _tmp21_ = 0;
	gdouble* _tmp22_ = NULL;
	gint _tmp23_ = 0;
	gdouble* _tmp24_ = NULL;
	gint _tmp35_ = 0;
	gint _tmp36_ = 0;
	gint _tmp37_ = 0;
	gint _tmp38_ = 0;
	gint* _tmp39_ = NULL;
	GThread* th = NULL;
	GThread* _tmp65_ = NULL;
	gdouble* _tmp66_ = NULL;
	gint _tmp66__length1 = 0;
	gdouble* _tmp67_ = NULL;
	gint _tmp67__length1 = 0;
	gdouble* _tmp68_ = NULL;
	gint _tmp68__length1 = 0;
	gint _tmp69_ = 0;
	gint _tmp70_ = 0;
	gint _tmp71_ = 0;
	gint _tmp72_ = 0;
	gint _tmp73_ = 0;
	gint* _tmp74_ = NULL;
	gint _tmp74__length1 = 0;
	gint _tmp74__length2 = 0;
	GThread* _tmp75_ = NULL;
	GThread* _tmp76_ = NULL;
	gdouble* _tmp77_ = NULL;
	gint _tmp77__length1 = 0;
	gint _tmp78_ = 0;
	gint _tmp79_ = 0;
	gint _tmp80_ = 0;
	gint _tmp81_ = 0;
	gint _tmp82_ = 0;
	gint* _tmp83_ = NULL;
	GThread* th2 = NULL;
	GThread* _tmp110_ = NULL;
	gdouble* _tmp111_ = NULL;
	gint _tmp111__length1 = 0;
	gdouble* _tmp112_ = NULL;
	gint _tmp112__length1 = 0;
	gdouble* _tmp113_ = NULL;
	gint _tmp113__length1 = 0;
	gint _tmp114_ = 0;
	gint _tmp115_ = 0;
	gint _tmp116_ = 0;
	gint _tmp117_ = 0;
	gint _tmp118_ = 0;
	gint* _tmp119_ = NULL;
	gint _tmp119__length1 = 0;
	gint _tmp119__length2 = 0;
	GThread* _tmp120_ = NULL;
	GThread* _tmp121_ = NULL;
	cairo_surface_t* _tmp132_ = NULL;
	cairo_t* target_cr = NULL;
	cairo_t* _tmp133_ = NULL;
	cairo_t* _tmp134_ = NULL;
	cairo_t* _tmp135_ = NULL;
	cairo_t* _tmp136_ = NULL;
	cairo_surface_t* _tmp137_ = NULL;
	cairo_t* _tmp138_ = NULL;
	cairo_t* _tmp139_ = NULL;
	g_return_if_fail (self != NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	_tmp0_ = radius;
	if (_tmp0_ < 1) {
		block5_data_unref (_data5_);
		_data5_ = NULL;
		return;
	}
	_tmp1_ = radius;
	_data5_->gaussWidth = (_tmp1_ * 2) + 1;
	_tmp2_ = _data5_->gaussWidth;
	_tmp4_ = plank_drawing_dock_surface_build_gaussian_kernel (_tmp2_, &_tmp3_);
	_data5_->kernel = _tmp4_;
	_data5_->kernel_length1 = _tmp3_;
	_data5_->_kernel_size_ = _data5_->kernel_length1;
	_tmp5_ = self->priv->_Width;
	_data5_->width = _tmp5_;
	_tmp6_ = self->priv->_Height;
	_data5_->height = _tmp6_;
	_tmp7_ = _data5_->width;
	_tmp8_ = _data5_->height;
	_tmp9_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp7_, _tmp8_);
	original = _tmp9_;
	_tmp10_ = original;
	_tmp11_ = cairo_create (_tmp10_);
	cr = _tmp11_;
	_tmp12_ = cr;
	cairo_set_operator (_tmp12_, CAIRO_OPERATOR_SOURCE);
	_tmp13_ = cr;
	_tmp14_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp13_, _tmp14_, (gdouble) 0, (gdouble) 0);
	_tmp15_ = cr;
	cairo_paint (_tmp15_);
	_tmp16_ = original;
	_tmp17_ = cairo_image_surface_get_data (_tmp16_);
	src = _tmp17_;
	_tmp18_ = _data5_->height;
	_tmp19_ = original;
	_tmp20_ = cairo_image_surface_get_stride (_tmp19_);
	size = _tmp18_ * _tmp20_;
	_tmp21_ = size;
	_tmp22_ = g_new0 (gdouble, _tmp21_);
	_data5_->abuffer = _tmp22_;
	_data5_->abuffer_length1 = _tmp21_;
	_data5_->_abuffer_size_ = _data5_->abuffer_length1;
	_tmp23_ = size;
	_tmp24_ = g_new0 (gdouble, _tmp23_);
	_data5_->bbuffer = _tmp24_;
	_data5_->bbuffer_length1 = _tmp23_;
	_data5_->_bbuffer_size_ = _data5_->bbuffer_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp25_ = FALSE;
			_tmp25_ = TRUE;
			while (TRUE) {
				gint _tmp27_ = 0;
				gint _tmp28_ = 0;
				gdouble* _tmp29_ = NULL;
				gint _tmp29__length1 = 0;
				gint _tmp30_ = 0;
				guint8* _tmp31_ = NULL;
				gint _tmp32_ = 0;
				guint8 _tmp33_ = 0U;
				gdouble _tmp34_ = 0.0;
				if (!_tmp25_) {
					gint _tmp26_ = 0;
					_tmp26_ = i;
					i = _tmp26_ + 1;
				}
				_tmp25_ = FALSE;
				_tmp27_ = i;
				_tmp28_ = size;
				if (!(_tmp27_ < _tmp28_)) {
					break;
				}
				_tmp29_ = _data5_->abuffer;
				_tmp29__length1 = _data5_->abuffer_length1;
				_tmp30_ = i;
				_tmp31_ = src;
				_tmp32_ = i;
				_tmp33_ = _tmp31_[_tmp32_];
				_tmp29_[_tmp30_] = (gdouble) _tmp33_;
				_tmp34_ = _tmp29_[_tmp30_];
			}
		}
	}
	_tmp35_ = _data5_->width;
	_tmp36_ = _data5_->height;
	_tmp37_ = MAX (_tmp35_, _tmp36_);
	_tmp38_ = _data5_->gaussWidth;
	_tmp39_ = g_new0 (gint, _tmp37_ * _tmp38_);
	_data5_->shiftar = _tmp39_;
	_data5_->shiftar_length1 = _tmp37_;
	_data5_->shiftar_length2 = _tmp38_;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp40_ = FALSE;
			_tmp40_ = TRUE;
			while (TRUE) {
				gint _tmp42_ = 0;
				gint _tmp43_ = 0;
				if (!_tmp40_) {
					gint _tmp41_ = 0;
					_tmp41_ = x;
					x = _tmp41_ + 1;
				}
				_tmp40_ = FALSE;
				_tmp42_ = x;
				_tmp43_ = _data5_->width;
				if (!(_tmp42_ < _tmp43_)) {
					break;
				}
				{
					gint k = 0;
					k = 0;
					{
						gboolean _tmp44_ = FALSE;
						_tmp44_ = TRUE;
						while (TRUE) {
							gint _tmp46_ = 0;
							gint _tmp47_ = 0;
							gint shift = 0;
							gint _tmp48_ = 0;
							gint _tmp49_ = 0;
							gboolean _tmp50_ = FALSE;
							gint _tmp51_ = 0;
							gint _tmp52_ = 0;
							if (!_tmp44_) {
								gint _tmp45_ = 0;
								_tmp45_ = k;
								k = _tmp45_ + 1;
							}
							_tmp44_ = FALSE;
							_tmp46_ = k;
							_tmp47_ = _data5_->gaussWidth;
							if (!(_tmp46_ < _tmp47_)) {
								break;
							}
							_tmp48_ = k;
							_tmp49_ = radius;
							shift = _tmp48_ - _tmp49_;
							_tmp51_ = x;
							_tmp52_ = shift;
							if ((_tmp51_ + _tmp52_) <= 0) {
								_tmp50_ = TRUE;
							} else {
								gint _tmp53_ = 0;
								gint _tmp54_ = 0;
								gint _tmp55_ = 0;
								_tmp53_ = x;
								_tmp54_ = shift;
								_tmp55_ = _data5_->width;
								_tmp50_ = (_tmp53_ + _tmp54_) >= _tmp55_;
							}
							if (_tmp50_) {
								gint* _tmp56_ = NULL;
								gint _tmp56__length1 = 0;
								gint _tmp56__length2 = 0;
								gint _tmp57_ = 0;
								gint _tmp58_ = 0;
								gint _tmp59_ = 0;
								_tmp56_ = _data5_->shiftar;
								_tmp56__length1 = _data5_->shiftar_length1;
								_tmp56__length2 = _data5_->shiftar_length2;
								_tmp57_ = x;
								_tmp58_ = k;
								_tmp56_[(_tmp57_ * _tmp56__length2) + _tmp58_] = 0;
								_tmp59_ = _tmp56_[(_tmp57_ * _tmp56__length2) + _tmp58_];
							} else {
								gint* _tmp60_ = NULL;
								gint _tmp60__length1 = 0;
								gint _tmp60__length2 = 0;
								gint _tmp61_ = 0;
								gint _tmp62_ = 0;
								gint _tmp63_ = 0;
								gint _tmp64_ = 0;
								_tmp60_ = _data5_->shiftar;
								_tmp60__length1 = _data5_->shiftar_length1;
								_tmp60__length2 = _data5_->shiftar_length2;
								_tmp61_ = x;
								_tmp62_ = k;
								_tmp63_ = shift;
								_tmp60_[(_tmp61_ * _tmp60__length2) + _tmp62_] = _tmp63_ * 4;
								_tmp64_ = _tmp60_[(_tmp61_ * _tmp60__length2) + _tmp62_];
							}
						}
					}
				}
			}
		}
	}
	_tmp65_ = g_thread_new (NULL, ___lambda6__gthread_func, block5_data_ref (_data5_));
	th = _tmp65_;
	_tmp66_ = _data5_->abuffer;
	_tmp66__length1 = _data5_->abuffer_length1;
	_tmp67_ = _data5_->bbuffer;
	_tmp67__length1 = _data5_->bbuffer_length1;
	_tmp68_ = _data5_->kernel;
	_tmp68__length1 = _data5_->kernel_length1;
	_tmp69_ = _data5_->gaussWidth;
	_tmp70_ = _data5_->width;
	_tmp71_ = _data5_->height;
	_tmp72_ = _data5_->height;
	_tmp73_ = _data5_->height;
	_tmp74_ = _data5_->shiftar;
	_tmp74__length1 = _data5_->shiftar_length1;
	_tmp74__length2 = _data5_->shiftar_length2;
	plank_drawing_dock_surface_gaussian_blur_horizontal (self, _tmp66_, _tmp67_, _tmp68_, _tmp69_, _tmp70_, _tmp71_, _tmp72_ / 2, _tmp73_, _tmp74_, _tmp74__length1, _tmp74__length2);
	_tmp75_ = th;
	_tmp76_ = _g_thread_ref0 (_tmp75_);
	g_thread_join (_tmp76_);
	_tmp77_ = _data5_->abuffer;
	_tmp77__length1 = _data5_->abuffer_length1;
	_tmp78_ = size;
	memset (_tmp77_, 0, (gsize) (sizeof (gdouble) * _tmp78_));
	_tmp79_ = _data5_->width;
	_tmp80_ = _data5_->height;
	_tmp81_ = MAX (_tmp79_, _tmp80_);
	_tmp82_ = _data5_->gaussWidth;
	_tmp83_ = g_new0 (gint, _tmp81_ * _tmp82_);
	_data5_->shiftar = (g_free (_data5_->shiftar), NULL);
	_data5_->shiftar = _tmp83_;
	_data5_->shiftar_length1 = _tmp81_;
	_data5_->shiftar_length2 = _tmp82_;
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp84_ = FALSE;
			_tmp84_ = TRUE;
			while (TRUE) {
				gint _tmp86_ = 0;
				gint _tmp87_ = 0;
				if (!_tmp84_) {
					gint _tmp85_ = 0;
					_tmp85_ = y;
					y = _tmp85_ + 1;
				}
				_tmp84_ = FALSE;
				_tmp86_ = y;
				_tmp87_ = _data5_->height;
				if (!(_tmp86_ < _tmp87_)) {
					break;
				}
				{
					gint k = 0;
					k = 0;
					{
						gboolean _tmp88_ = FALSE;
						_tmp88_ = TRUE;
						while (TRUE) {
							gint _tmp90_ = 0;
							gint _tmp91_ = 0;
							gint shift = 0;
							gint _tmp92_ = 0;
							gint _tmp93_ = 0;
							gboolean _tmp94_ = FALSE;
							gint _tmp95_ = 0;
							gint _tmp96_ = 0;
							if (!_tmp88_) {
								gint _tmp89_ = 0;
								_tmp89_ = k;
								k = _tmp89_ + 1;
							}
							_tmp88_ = FALSE;
							_tmp90_ = k;
							_tmp91_ = _data5_->gaussWidth;
							if (!(_tmp90_ < _tmp91_)) {
								break;
							}
							_tmp92_ = k;
							_tmp93_ = radius;
							shift = _tmp92_ - _tmp93_;
							_tmp95_ = y;
							_tmp96_ = shift;
							if ((_tmp95_ + _tmp96_) <= 0) {
								_tmp94_ = TRUE;
							} else {
								gint _tmp97_ = 0;
								gint _tmp98_ = 0;
								gint _tmp99_ = 0;
								_tmp97_ = y;
								_tmp98_ = shift;
								_tmp99_ = _data5_->height;
								_tmp94_ = (_tmp97_ + _tmp98_) >= _tmp99_;
							}
							if (_tmp94_) {
								gint* _tmp100_ = NULL;
								gint _tmp100__length1 = 0;
								gint _tmp100__length2 = 0;
								gint _tmp101_ = 0;
								gint _tmp102_ = 0;
								gint _tmp103_ = 0;
								_tmp100_ = _data5_->shiftar;
								_tmp100__length1 = _data5_->shiftar_length1;
								_tmp100__length2 = _data5_->shiftar_length2;
								_tmp101_ = y;
								_tmp102_ = k;
								_tmp100_[(_tmp101_ * _tmp100__length2) + _tmp102_] = 0;
								_tmp103_ = _tmp100_[(_tmp101_ * _tmp100__length2) + _tmp102_];
							} else {
								gint* _tmp104_ = NULL;
								gint _tmp104__length1 = 0;
								gint _tmp104__length2 = 0;
								gint _tmp105_ = 0;
								gint _tmp106_ = 0;
								gint _tmp107_ = 0;
								gint _tmp108_ = 0;
								gint _tmp109_ = 0;
								_tmp104_ = _data5_->shiftar;
								_tmp104__length1 = _data5_->shiftar_length1;
								_tmp104__length2 = _data5_->shiftar_length2;
								_tmp105_ = y;
								_tmp106_ = k;
								_tmp107_ = shift;
								_tmp108_ = _data5_->width;
								_tmp104_[(_tmp105_ * _tmp104__length2) + _tmp106_] = (_tmp107_ * _tmp108_) * 4;
								_tmp109_ = _tmp104_[(_tmp105_ * _tmp104__length2) + _tmp106_];
							}
						}
					}
				}
			}
		}
	}
	_tmp110_ = g_thread_new (NULL, ___lambda7__gthread_func, block5_data_ref (_data5_));
	th2 = _tmp110_;
	_tmp111_ = _data5_->bbuffer;
	_tmp111__length1 = _data5_->bbuffer_length1;
	_tmp112_ = _data5_->abuffer;
	_tmp112__length1 = _data5_->abuffer_length1;
	_tmp113_ = _data5_->kernel;
	_tmp113__length1 = _data5_->kernel_length1;
	_tmp114_ = _data5_->gaussWidth;
	_tmp115_ = _data5_->width;
	_tmp116_ = _data5_->height;
	_tmp117_ = _data5_->width;
	_tmp118_ = _data5_->width;
	_tmp119_ = _data5_->shiftar;
	_tmp119__length1 = _data5_->shiftar_length1;
	_tmp119__length2 = _data5_->shiftar_length2;
	plank_drawing_dock_surface_gaussian_blur_vertical (self, _tmp111_, _tmp112_, _tmp113_, _tmp114_, _tmp115_, _tmp116_, _tmp117_ / 2, _tmp118_, _tmp119_, _tmp119__length1, _tmp119__length2);
	_tmp120_ = th2;
	_tmp121_ = _g_thread_ref0 (_tmp120_);
	g_thread_join (_tmp121_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp122_ = FALSE;
			_tmp122_ = TRUE;
			while (TRUE) {
				gint _tmp124_ = 0;
				gint _tmp125_ = 0;
				guint8* _tmp126_ = NULL;
				gint _tmp127_ = 0;
				gdouble* _tmp128_ = NULL;
				gint _tmp128__length1 = 0;
				gint _tmp129_ = 0;
				gdouble _tmp130_ = 0.0;
				guint8 _tmp131_ = 0U;
				if (!_tmp122_) {
					gint _tmp123_ = 0;
					_tmp123_ = i;
					i = _tmp123_ + 1;
				}
				_tmp122_ = FALSE;
				_tmp124_ = i;
				_tmp125_ = size;
				if (!(_tmp124_ < _tmp125_)) {
					break;
				}
				_tmp126_ = src;
				_tmp127_ = i;
				_tmp128_ = _data5_->abuffer;
				_tmp128__length1 = _data5_->abuffer_length1;
				_tmp129_ = i;
				_tmp130_ = _tmp128_[_tmp129_];
				_tmp126_[_tmp127_] = (guint8) _tmp130_;
				_tmp131_ = _tmp126_[_tmp127_];
			}
		}
	}
	_tmp132_ = original;
	cairo_surface_mark_dirty (_tmp132_);
	_tmp133_ = self->priv->_Context;
	target_cr = _tmp133_;
	_tmp134_ = target_cr;
	cairo_save (_tmp134_);
	_tmp135_ = target_cr;
	cairo_set_operator (_tmp135_, CAIRO_OPERATOR_SOURCE);
	_tmp136_ = target_cr;
	_tmp137_ = original;
	cairo_set_source_surface (_tmp136_, _tmp137_, (gdouble) 0, (gdouble) 0);
	_tmp138_ = target_cr;
	cairo_paint (_tmp138_);
	_tmp139_ = target_cr;
	cairo_restore (_tmp139_);
	_g_thread_unref0 (th2);
	_g_thread_unref0 (th);
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (original);
	block5_data_unref (_data5_);
	_data5_ = NULL;
}


static void plank_drawing_dock_surface_gaussian_blur_horizontal (PlankDrawingDockSurface* self, gdouble* src, gdouble* dest, gdouble* kernel, gint gaussWidth, gint width, gint height, gint startRow, gint endRow, gint* shift, int shift_length1, int shift_length2) {
	guint32 cur_pixel = 0U;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = startRow;
	_tmp1_ = width;
	cur_pixel = (guint32) ((_tmp0_ * _tmp1_) * 4);
	{
		gint y = 0;
		gint _tmp2_ = 0;
		_tmp2_ = startRow;
		y = _tmp2_;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_ = 0;
				gint _tmp6_ = 0;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = y;
					y = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = y;
				_tmp6_ = endRow;
				if (!(_tmp5_ < _tmp6_)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp7_ = FALSE;
						_tmp7_ = TRUE;
						while (TRUE) {
							gint _tmp9_ = 0;
							gint _tmp10_ = 0;
							guint32 _tmp51_ = 0U;
							if (!_tmp7_) {
								gint _tmp8_ = 0;
								_tmp8_ = x;
								x = _tmp8_ + 1;
							}
							_tmp7_ = FALSE;
							_tmp9_ = x;
							_tmp10_ = width;
							if (!(_tmp9_ < _tmp10_)) {
								break;
							}
							{
								gint k = 0;
								k = 0;
								{
									gboolean _tmp11_ = FALSE;
									_tmp11_ = TRUE;
									while (TRUE) {
										gint _tmp13_ = 0;
										gint _tmp14_ = 0;
										guint32 source = 0U;
										guint32 _tmp15_ = 0U;
										gint* _tmp16_ = NULL;
										gint _tmp16__length1 = 0;
										gint _tmp16__length2 = 0;
										gint _tmp17_ = 0;
										gint _tmp18_ = 0;
										gint _tmp19_ = 0;
										gdouble kernel_k = 0.0;
										gdouble* _tmp20_ = NULL;
										gint _tmp21_ = 0;
										gdouble _tmp22_ = 0.0;
										gdouble* _tmp23_ = NULL;
										guint32 _tmp24_ = 0U;
										gdouble* _tmp25_ = NULL;
										guint32 _tmp26_ = 0U;
										gdouble _tmp27_ = 0.0;
										gdouble _tmp28_ = 0.0;
										gdouble _tmp29_ = 0.0;
										gdouble* _tmp30_ = NULL;
										guint32 _tmp31_ = 0U;
										gdouble* _tmp32_ = NULL;
										guint32 _tmp33_ = 0U;
										gdouble _tmp34_ = 0.0;
										gdouble _tmp35_ = 0.0;
										gdouble _tmp36_ = 0.0;
										gdouble* _tmp37_ = NULL;
										guint32 _tmp38_ = 0U;
										gdouble* _tmp39_ = NULL;
										guint32 _tmp40_ = 0U;
										gdouble _tmp41_ = 0.0;
										gdouble _tmp42_ = 0.0;
										gdouble _tmp43_ = 0.0;
										gdouble* _tmp44_ = NULL;
										guint32 _tmp45_ = 0U;
										gdouble* _tmp46_ = NULL;
										guint32 _tmp47_ = 0U;
										gdouble _tmp48_ = 0.0;
										gdouble _tmp49_ = 0.0;
										gdouble _tmp50_ = 0.0;
										if (!_tmp11_) {
											gint _tmp12_ = 0;
											_tmp12_ = k;
											k = _tmp12_ + 1;
										}
										_tmp11_ = FALSE;
										_tmp13_ = k;
										_tmp14_ = gaussWidth;
										if (!(_tmp13_ < _tmp14_)) {
											break;
										}
										_tmp15_ = cur_pixel;
										_tmp16_ = shift;
										_tmp16__length1 = shift_length1;
										_tmp16__length2 = shift_length2;
										_tmp17_ = x;
										_tmp18_ = k;
										_tmp19_ = _tmp16_[(_tmp17_ * _tmp16__length2) + _tmp18_];
										source = _tmp15_ + _tmp19_;
										_tmp20_ = kernel;
										_tmp21_ = k;
										_tmp22_ = _tmp20_[_tmp21_];
										kernel_k = _tmp22_;
										_tmp23_ = dest;
										_tmp24_ = cur_pixel;
										_tmp25_ = src;
										_tmp26_ = source;
										_tmp27_ = _tmp25_[_tmp26_ + 0];
										_tmp28_ = kernel_k;
										_tmp23_[_tmp24_ + 0] += _tmp27_ * _tmp28_;
										_tmp29_ = _tmp23_[_tmp24_ + 0];
										_tmp30_ = dest;
										_tmp31_ = cur_pixel;
										_tmp32_ = src;
										_tmp33_ = source;
										_tmp34_ = _tmp32_[_tmp33_ + 1];
										_tmp35_ = kernel_k;
										_tmp30_[_tmp31_ + 1] += _tmp34_ * _tmp35_;
										_tmp36_ = _tmp30_[_tmp31_ + 1];
										_tmp37_ = dest;
										_tmp38_ = cur_pixel;
										_tmp39_ = src;
										_tmp40_ = source;
										_tmp41_ = _tmp39_[_tmp40_ + 2];
										_tmp42_ = kernel_k;
										_tmp37_[_tmp38_ + 2] += _tmp41_ * _tmp42_;
										_tmp43_ = _tmp37_[_tmp38_ + 2];
										_tmp44_ = dest;
										_tmp45_ = cur_pixel;
										_tmp46_ = src;
										_tmp47_ = source;
										_tmp48_ = _tmp46_[_tmp47_ + 3];
										_tmp49_ = kernel_k;
										_tmp44_[_tmp45_ + 3] += _tmp48_ * _tmp49_;
										_tmp50_ = _tmp44_[_tmp45_ + 3];
									}
								}
							}
							_tmp51_ = cur_pixel;
							cur_pixel = _tmp51_ + 4;
						}
					}
				}
			}
		}
	}
}


static void plank_drawing_dock_surface_gaussian_blur_vertical (PlankDrawingDockSurface* self, gdouble* src, gdouble* dest, gdouble* kernel, gint gaussWidth, gint width, gint height, gint startCol, gint endCol, gint* shift, int shift_length1, int shift_length2) {
	guint32 cur_pixel = 0U;
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = startCol;
	cur_pixel = (guint32) (_tmp0_ * 4);
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_ = 0;
				gint _tmp4_ = 0;
				guint32 _tmp51_ = 0U;
				gint _tmp52_ = 0;
				gint _tmp53_ = 0;
				gint _tmp54_ = 0;
				if (!_tmp1_) {
					gint _tmp2_ = 0;
					_tmp2_ = y;
					y = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = y;
				_tmp4_ = height;
				if (!(_tmp3_ < _tmp4_)) {
					break;
				}
				{
					gint x = 0;
					gint _tmp5_ = 0;
					_tmp5_ = startCol;
					x = _tmp5_;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							gint _tmp8_ = 0;
							gint _tmp9_ = 0;
							guint32 _tmp50_ = 0U;
							if (!_tmp6_) {
								gint _tmp7_ = 0;
								_tmp7_ = x;
								x = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = x;
							_tmp9_ = endCol;
							if (!(_tmp8_ < _tmp9_)) {
								break;
							}
							{
								gint k = 0;
								k = 0;
								{
									gboolean _tmp10_ = FALSE;
									_tmp10_ = TRUE;
									while (TRUE) {
										gint _tmp12_ = 0;
										gint _tmp13_ = 0;
										guint32 source = 0U;
										guint32 _tmp14_ = 0U;
										gint* _tmp15_ = NULL;
										gint _tmp15__length1 = 0;
										gint _tmp15__length2 = 0;
										gint _tmp16_ = 0;
										gint _tmp17_ = 0;
										gint _tmp18_ = 0;
										gdouble kernel_k = 0.0;
										gdouble* _tmp19_ = NULL;
										gint _tmp20_ = 0;
										gdouble _tmp21_ = 0.0;
										gdouble* _tmp22_ = NULL;
										guint32 _tmp23_ = 0U;
										gdouble* _tmp24_ = NULL;
										guint32 _tmp25_ = 0U;
										gdouble _tmp26_ = 0.0;
										gdouble _tmp27_ = 0.0;
										gdouble _tmp28_ = 0.0;
										gdouble* _tmp29_ = NULL;
										guint32 _tmp30_ = 0U;
										gdouble* _tmp31_ = NULL;
										guint32 _tmp32_ = 0U;
										gdouble _tmp33_ = 0.0;
										gdouble _tmp34_ = 0.0;
										gdouble _tmp35_ = 0.0;
										gdouble* _tmp36_ = NULL;
										guint32 _tmp37_ = 0U;
										gdouble* _tmp38_ = NULL;
										guint32 _tmp39_ = 0U;
										gdouble _tmp40_ = 0.0;
										gdouble _tmp41_ = 0.0;
										gdouble _tmp42_ = 0.0;
										gdouble* _tmp43_ = NULL;
										guint32 _tmp44_ = 0U;
										gdouble* _tmp45_ = NULL;
										guint32 _tmp46_ = 0U;
										gdouble _tmp47_ = 0.0;
										gdouble _tmp48_ = 0.0;
										gdouble _tmp49_ = 0.0;
										if (!_tmp10_) {
											gint _tmp11_ = 0;
											_tmp11_ = k;
											k = _tmp11_ + 1;
										}
										_tmp10_ = FALSE;
										_tmp12_ = k;
										_tmp13_ = gaussWidth;
										if (!(_tmp12_ < _tmp13_)) {
											break;
										}
										_tmp14_ = cur_pixel;
										_tmp15_ = shift;
										_tmp15__length1 = shift_length1;
										_tmp15__length2 = shift_length2;
										_tmp16_ = y;
										_tmp17_ = k;
										_tmp18_ = _tmp15_[(_tmp16_ * _tmp15__length2) + _tmp17_];
										source = _tmp14_ + _tmp18_;
										_tmp19_ = kernel;
										_tmp20_ = k;
										_tmp21_ = _tmp19_[_tmp20_];
										kernel_k = _tmp21_;
										_tmp22_ = dest;
										_tmp23_ = cur_pixel;
										_tmp24_ = src;
										_tmp25_ = source;
										_tmp26_ = _tmp24_[_tmp25_ + 0];
										_tmp27_ = kernel_k;
										_tmp22_[_tmp23_ + 0] += _tmp26_ * _tmp27_;
										_tmp28_ = _tmp22_[_tmp23_ + 0];
										_tmp29_ = dest;
										_tmp30_ = cur_pixel;
										_tmp31_ = src;
										_tmp32_ = source;
										_tmp33_ = _tmp31_[_tmp32_ + 1];
										_tmp34_ = kernel_k;
										_tmp29_[_tmp30_ + 1] += _tmp33_ * _tmp34_;
										_tmp35_ = _tmp29_[_tmp30_ + 1];
										_tmp36_ = dest;
										_tmp37_ = cur_pixel;
										_tmp38_ = src;
										_tmp39_ = source;
										_tmp40_ = _tmp38_[_tmp39_ + 2];
										_tmp41_ = kernel_k;
										_tmp36_[_tmp37_ + 2] += _tmp40_ * _tmp41_;
										_tmp42_ = _tmp36_[_tmp37_ + 2];
										_tmp43_ = dest;
										_tmp44_ = cur_pixel;
										_tmp45_ = src;
										_tmp46_ = source;
										_tmp47_ = _tmp45_[_tmp46_ + 3];
										_tmp48_ = kernel_k;
										_tmp43_[_tmp44_ + 3] += _tmp47_ * _tmp48_;
										_tmp49_ = _tmp43_[_tmp44_ + 3];
									}
								}
							}
							_tmp50_ = cur_pixel;
							cur_pixel = _tmp50_ + 4;
						}
					}
				}
				_tmp51_ = cur_pixel;
				_tmp52_ = width;
				_tmp53_ = endCol;
				_tmp54_ = startCol;
				cur_pixel = _tmp51_ + (((_tmp52_ - _tmp53_) + _tmp54_) * 4);
			}
		}
	}
}


static gdouble* plank_drawing_dock_surface_build_gaussian_kernel (gint gaussWidth, int* result_length1) {
	gdouble* result = NULL;
	gint _tmp0_ = 0;
	gdouble* kernel = NULL;
	gint _tmp1_ = 0;
	gdouble* _tmp2_ = NULL;
	gint kernel_length1 = 0;
	gint _kernel_size_ = 0;
	gdouble sd = 0.0;
	gint range = 0;
	gint _tmp3_ = 0;
	gdouble mean = 0.0;
	gint _tmp4_ = 0;
	gdouble _tmp5_ = 0.0;
	gdouble gaussSum = 0.0;
	gdouble* _tmp23_ = NULL;
	gint _tmp23__length1 = 0;
	gdouble* _tmp37_ = NULL;
	gint _tmp37__length1 = 0;
	_tmp0_ = gaussWidth;
	_vala_return_val_if_fail ((_tmp0_ % 2) == 1, "gaussWidth % 2 == 1", NULL);
	_tmp1_ = gaussWidth;
	_tmp2_ = g_new0 (gdouble, _tmp1_);
	kernel = _tmp2_;
	kernel_length1 = _tmp1_;
	_kernel_size_ = kernel_length1;
	sd = 255.0;
	_tmp3_ = gaussWidth;
	range = _tmp3_;
	_tmp4_ = range;
	_tmp5_ = sd;
	mean = _tmp4_ / _tmp5_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				gdouble* _tmp10_ = NULL;
				gint _tmp10__length1 = 0;
				gint _tmp11_ = 0;
				gint _tmp12_ = 0;
				gdouble* _tmp13_ = NULL;
				gint _tmp13__length1 = 0;
				gint _tmp14_ = 0;
				gint _tmp15_ = 0;
				gdouble _tmp16_ = 0.0;
				gint _tmp17_ = 0;
				gdouble _tmp18_ = 0.0;
				gdouble _tmp19_ = 0.0;
				gdouble _tmp20_ = 0.0;
				gdouble _tmp21_ = 0.0;
				gdouble _tmp22_ = 0.0;
				if (!_tmp6_) {
					gint _tmp7_ = 0;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = i;
				_tmp9_ = gaussWidth;
				if (!(_tmp8_ < ((_tmp9_ / 2) + 1))) {
					break;
				}
				_tmp10_ = kernel;
				_tmp10__length1 = kernel_length1;
				_tmp11_ = gaussWidth;
				_tmp12_ = i;
				_tmp13_ = kernel;
				_tmp13__length1 = kernel_length1;
				_tmp14_ = i;
				_tmp15_ = i;
				_tmp16_ = mean;
				_tmp17_ = range;
				_tmp18_ = sin ((((_tmp15_ + 1) * G_PI_2) - _tmp16_) / _tmp17_);
				_tmp19_ = pow (_tmp18_, (gdouble) 2);
				_tmp20_ = sd;
				_tmp13_[_tmp14_] = _tmp19_ * _tmp20_;
				_tmp21_ = _tmp13_[_tmp14_];
				_tmp10_[(_tmp11_ - _tmp12_) - 1] = _tmp21_;
				_tmp22_ = _tmp10_[(_tmp11_ - _tmp12_) - 1];
			}
		}
	}
	gaussSum = 0.0;
	_tmp23_ = kernel;
	_tmp23__length1 = kernel_length1;
	{
		gdouble* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
		d_collection = _tmp23_;
		d_collection_length1 = _tmp23__length1;
		for (d_it = 0; d_it < _tmp23__length1; d_it = d_it + 1) {
			gdouble d = 0.0;
			d = d_collection[d_it];
			{
				gdouble _tmp24_ = 0.0;
				gdouble _tmp25_ = 0.0;
				_tmp24_ = gaussSum;
				_tmp25_ = d;
				gaussSum = _tmp24_ + _tmp25_;
			}
		}
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp26_ = FALSE;
			_tmp26_ = TRUE;
			while (TRUE) {
				gint _tmp28_ = 0;
				gdouble* _tmp29_ = NULL;
				gint _tmp29__length1 = 0;
				gdouble* _tmp30_ = NULL;
				gint _tmp30__length1 = 0;
				gint _tmp31_ = 0;
				gdouble* _tmp32_ = NULL;
				gint _tmp32__length1 = 0;
				gint _tmp33_ = 0;
				gdouble _tmp34_ = 0.0;
				gdouble _tmp35_ = 0.0;
				gdouble _tmp36_ = 0.0;
				if (!_tmp26_) {
					gint _tmp27_ = 0;
					_tmp27_ = i;
					i = _tmp27_ + 1;
				}
				_tmp26_ = FALSE;
				_tmp28_ = i;
				_tmp29_ = kernel;
				_tmp29__length1 = kernel_length1;
				if (!(_tmp28_ < _tmp29__length1)) {
					break;
				}
				_tmp30_ = kernel;
				_tmp30__length1 = kernel_length1;
				_tmp31_ = i;
				_tmp32_ = kernel;
				_tmp32__length1 = kernel_length1;
				_tmp33_ = i;
				_tmp34_ = _tmp32_[_tmp33_];
				_tmp35_ = gaussSum;
				_tmp30_[_tmp31_] = _tmp34_ / _tmp35_;
				_tmp36_ = _tmp30_[_tmp31_];
			}
		}
	}
	_tmp37_ = kernel;
	_tmp37__length1 = kernel_length1;
	if (result_length1) {
		*result_length1 = _tmp37__length1;
	}
	result = _tmp37_;
	return result;
}


cairo_surface_t* plank_drawing_dock_surface_get_Internal (PlankDrawingDockSurface* self) {
	cairo_surface_t* result;
	cairo_surface_t* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Internal;
	result = _tmp0_;
	return result;
}


static gpointer _cairo_surface_reference0 (gpointer self) {
	return self ? cairo_surface_reference (self) : NULL;
}


static void plank_drawing_dock_surface_set_Internal (PlankDrawingDockSurface* self, cairo_surface_t* value) {
	cairo_surface_t* _tmp0_ = NULL;
	cairo_surface_t* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _cairo_surface_reference0 (_tmp0_);
	_cairo_surface_destroy0 (self->priv->_Internal);
	self->priv->_Internal = _tmp1_;
	g_object_notify ((GObject *) self, "Internal");
}


gint plank_drawing_dock_surface_get_Width (PlankDrawingDockSurface* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_Width;
	result = _tmp0_;
	return result;
}


static void plank_drawing_dock_surface_set_Width (PlankDrawingDockSurface* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_Width = _tmp0_;
	g_object_notify ((GObject *) self, "Width");
}


gint plank_drawing_dock_surface_get_Height (PlankDrawingDockSurface* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_Height;
	result = _tmp0_;
	return result;
}


static void plank_drawing_dock_surface_set_Height (PlankDrawingDockSurface* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_Height = _tmp0_;
	g_object_notify ((GObject *) self, "Height");
}


cairo_t* plank_drawing_dock_surface_get_Context (PlankDrawingDockSurface* self) {
	cairo_t* result;
	cairo_t* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Context;
	result = _tmp0_;
	return result;
}


static gpointer _cairo_reference0 (gpointer self) {
	return self ? cairo_reference (self) : NULL;
}


static void plank_drawing_dock_surface_set_Context (PlankDrawingDockSurface* self, cairo_t* value) {
	cairo_t* _tmp0_ = NULL;
	cairo_t* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _cairo_reference0 (_tmp0_);
	_cairo_destroy0 (self->priv->_Context);
	self->priv->_Context = _tmp1_;
	g_object_notify ((GObject *) self, "Context");
}


static GObject * plank_drawing_dock_surface_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	PlankDrawingDockSurface * self;
	cairo_surface_t* _tmp0_ = NULL;
	cairo_t* _tmp1_ = NULL;
	cairo_t* _tmp2_ = NULL;
	parent_class = G_OBJECT_CLASS (plank_drawing_dock_surface_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_DRAWING_TYPE_DOCK_SURFACE, PlankDrawingDockSurface);
	_tmp0_ = self->priv->_Internal;
	_tmp1_ = cairo_create (_tmp0_);
	_tmp2_ = _tmp1_;
	plank_drawing_dock_surface_set_Context (self, _tmp2_);
	_cairo_destroy0 (_tmp2_);
	return obj;
}


static void plank_drawing_dock_surface_class_init (PlankDrawingDockSurfaceClass * klass) {
	plank_drawing_dock_surface_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PlankDrawingDockSurfacePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_drawing_dock_surface_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_drawing_dock_surface_set_property;
	G_OBJECT_CLASS (klass)->constructor = plank_drawing_dock_surface_constructor;
	G_OBJECT_CLASS (klass)->finalize = plank_drawing_dock_surface_finalize;
	/**
	 * The internal {@link Cairo.Surface} backing the dock surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DRAWING_DOCK_SURFACE_INTERNAL, g_param_spec_pointer ("Internal", "Internal", "Internal", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * The width of the surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DRAWING_DOCK_SURFACE_WIDTH, g_param_spec_int ("Width", "Width", "Width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * The height of the surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DRAWING_DOCK_SURFACE_HEIGHT, g_param_spec_int ("Height", "Height", "Height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * A {@link Cairo.Context} for the dock surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DRAWING_DOCK_SURFACE_CONTEXT, g_param_spec_pointer ("Context", "Context", "Context", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void plank_drawing_dock_surface_instance_init (PlankDrawingDockSurface * self) {
	self->priv = PLANK_DRAWING_DOCK_SURFACE_GET_PRIVATE (self);
}


static void plank_drawing_dock_surface_finalize (GObject* obj) {
	PlankDrawingDockSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_DRAWING_TYPE_DOCK_SURFACE, PlankDrawingDockSurface);
	_cairo_surface_destroy0 (self->priv->_Internal);
	_cairo_destroy0 (self->priv->_Context);
	G_OBJECT_CLASS (plank_drawing_dock_surface_parent_class)->finalize (obj);
}


/**
 * A dock surface is a wrapper class for a {@link Cairo.Surface}.
 * It encapsulates a surface/context and provides utility methods.
 */
GType plank_drawing_dock_surface_get_type (void) {
	static volatile gsize plank_drawing_dock_surface_type_id__volatile = 0;
	if (g_once_init_enter (&plank_drawing_dock_surface_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankDrawingDockSurfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_drawing_dock_surface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDrawingDockSurface), 0, (GInstanceInitFunc) plank_drawing_dock_surface_instance_init, NULL };
		GType plank_drawing_dock_surface_type_id;
		plank_drawing_dock_surface_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankDrawingDockSurface", &g_define_type_info, 0);
		g_once_init_leave (&plank_drawing_dock_surface_type_id__volatile, plank_drawing_dock_surface_type_id);
	}
	return plank_drawing_dock_surface_type_id__volatile;
}


static void _vala_plank_drawing_dock_surface_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PlankDrawingDockSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_DRAWING_TYPE_DOCK_SURFACE, PlankDrawingDockSurface);
	switch (property_id) {
		case PLANK_DRAWING_DOCK_SURFACE_INTERNAL:
		g_value_set_pointer (value, plank_drawing_dock_surface_get_Internal (self));
		break;
		case PLANK_DRAWING_DOCK_SURFACE_WIDTH:
		g_value_set_int (value, plank_drawing_dock_surface_get_Width (self));
		break;
		case PLANK_DRAWING_DOCK_SURFACE_HEIGHT:
		g_value_set_int (value, plank_drawing_dock_surface_get_Height (self));
		break;
		case PLANK_DRAWING_DOCK_SURFACE_CONTEXT:
		g_value_set_pointer (value, plank_drawing_dock_surface_get_Context (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_plank_drawing_dock_surface_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PlankDrawingDockSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_DRAWING_TYPE_DOCK_SURFACE, PlankDrawingDockSurface);
	switch (property_id) {
		case PLANK_DRAWING_DOCK_SURFACE_INTERNAL:
		plank_drawing_dock_surface_set_Internal (self, g_value_get_pointer (value));
		break;
		case PLANK_DRAWING_DOCK_SURFACE_WIDTH:
		plank_drawing_dock_surface_set_Width (self, g_value_get_int (value));
		break;
		case PLANK_DRAWING_DOCK_SURFACE_HEIGHT:
		plank_drawing_dock_surface_set_Height (self, g_value_get_int (value));
		break;
		case PLANK_DRAWING_DOCK_SURFACE_CONTEXT:
		plank_drawing_dock_surface_set_Context (self, g_value_get_pointer (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



