/* DrawingService.c generated by valac 0.28.1, the Vala compiler
 * generated from DrawingService.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo.h>


#define PLANK_DRAWING_TYPE_DRAWING_SERVICE (plank_drawing_drawing_service_get_type ())
#define PLANK_DRAWING_DRAWING_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_DRAWING_TYPE_DRAWING_SERVICE, PlankDrawingDrawingService))
#define PLANK_DRAWING_DRAWING_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_DRAWING_TYPE_DRAWING_SERVICE, PlankDrawingDrawingServiceClass))
#define PLANK_DRAWING_IS_DRAWING_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_DRAWING_TYPE_DRAWING_SERVICE))
#define PLANK_DRAWING_IS_DRAWING_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_DRAWING_TYPE_DRAWING_SERVICE))
#define PLANK_DRAWING_DRAWING_SERVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_DRAWING_TYPE_DRAWING_SERVICE, PlankDrawingDrawingServiceClass))

typedef struct _PlankDrawingDrawingService PlankDrawingDrawingService;
typedef struct _PlankDrawingDrawingServiceClass PlankDrawingDrawingServiceClass;
typedef struct _PlankDrawingDrawingServicePrivate PlankDrawingDrawingServicePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))

#define PLANK_DRAWING_TYPE_COLOR (plank_drawing_color_get_type ())
typedef GdkRGBA PlankDrawingColor;

struct _PlankDrawingDrawingService {
	GObject parent_instance;
	PlankDrawingDrawingServicePrivate * priv;
};

struct _PlankDrawingDrawingServiceClass {
	GObjectClass parent_class;
};


static gpointer plank_drawing_drawing_service_parent_class = NULL;
static GMutex plank_drawing_drawing_service_icon_theme_mutex;
static GMutex plank_drawing_drawing_service_icon_theme_mutex = {0};
static GtkIconTheme* plank_drawing_drawing_service_icon_theme;
static GtkIconTheme* plank_drawing_drawing_service_icon_theme = NULL;

GType plank_drawing_drawing_service_get_type (void) G_GNUC_CONST;
enum  {
	PLANK_DRAWING_DRAWING_SERVICE_DUMMY_PROPERTY
};
#define PLANK_DRAWING_DRAWING_SERVICE_DEFAULT_ICON "application-default-icon"
#define PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON "metadata::custom-icon"
#define PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME "metadata::custom-icon-name"
#define PLANK_DRAWING_DRAWING_SERVICE_SATURATION_WEIGHT 1.5
#define PLANK_DRAWING_DRAWING_SERVICE_WEIGHT_THRESHOLD 1.0
#define PLANK_DRAWING_DRAWING_SERVICE_ALPHA_THRESHOLD ((guint8) 24)
static PlankDrawingDrawingService* plank_drawing_drawing_service_new (void);
static PlankDrawingDrawingService* plank_drawing_drawing_service_construct (GType object_type);
GtkIconTheme* plank_drawing_drawing_service_get_icon_theme (void);
gchar* plank_drawing_drawing_service_get_icon_from_file (GFile* file);
gchar* plank_drawing_drawing_service_get_icon_from_gicon (GIcon* icon);
GdkPixbuf* plank_drawing_drawing_service_load_icon (const gchar* names, gint width, gint height);
static void _vala_array_add3 (gchar*** array, int* length, int* size, gchar* value);
GFile* plank_drawing_drawing_service_try_get_icon_file (const gchar* name);
static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf_from_file (GFile* file, gint width, gint height);
static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf (const gchar* icon, gint size);
static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf_from_resource (const gchar* resource, gint width, gint height);
#define PLANK_G_RESOURCE_PATH "/net/launchpad/plank"
GdkPixbuf* plank_drawing_drawing_service_ar_scale (GdkPixbuf* source, gint width, gint height);
static GdkPixbuf* plank_drawing_drawing_service_get_empty_pixbuf (gint width, gint height);
cairo_surface_t* plank_drawing_drawing_service_load_icon_for_scale (const gchar* names, gint width, gint height, gint scale);
static void _vala_array_add4 (gchar*** array, int* length, int* size, gchar* value);
static cairo_surface_t* plank_drawing_drawing_service_load_surface (const gchar* icon, gint size, gint scale);
static cairo_surface_t* plank_drawing_drawing_service_load_surface_from_resource_at_scale (const gchar* resource, gint width, gint height, gint scale);
GType plank_drawing_color_get_type (void) G_GNUC_CONST;
PlankDrawingColor* plank_drawing_color_dup (const PlankDrawingColor* self);
void plank_drawing_color_free (PlankDrawingColor* self);
void plank_drawing_drawing_service_average_color (GdkPixbuf* source, PlankDrawingColor* result);
static void plank_drawing_drawing_service_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static PlankDrawingDrawingService* plank_drawing_drawing_service_construct (GType object_type) {
	PlankDrawingDrawingService * self = NULL;
	self = (PlankDrawingDrawingService*) g_object_new (object_type, NULL);
	return self;
}


static PlankDrawingDrawingService* plank_drawing_drawing_service_new (void) {
	return plank_drawing_drawing_service_construct (PLANK_DRAWING_TYPE_DRAWING_SERVICE);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GtkIconTheme* plank_drawing_drawing_service_get_icon_theme (void) {
	GtkIconTheme* result = NULL;
	GtkIconTheme* _tmp0_ = NULL;
	GtkIconTheme* _tmp4_ = NULL;
	g_mutex_lock (&plank_drawing_drawing_service_icon_theme_mutex);
	_tmp0_ = plank_drawing_drawing_service_icon_theme;
	if (_tmp0_ == NULL) {
		GdkScreen* _tmp1_ = NULL;
		GtkIconTheme* _tmp2_ = NULL;
		GtkIconTheme* _tmp3_ = NULL;
		_tmp1_ = gdk_screen_get_default ();
		_tmp2_ = gtk_icon_theme_get_for_screen (_tmp1_);
		_tmp3_ = _g_object_ref0 (_tmp2_);
		_g_object_unref0 (plank_drawing_drawing_service_icon_theme);
		plank_drawing_drawing_service_icon_theme = _tmp3_;
	}
	g_mutex_unlock (&plank_drawing_drawing_service_icon_theme_mutex);
	_tmp4_ = plank_drawing_drawing_service_icon_theme;
	result = _tmp4_;
	return result;
}


/**
 * Gets the icon name from a {@link GLib.File}.
 *
 * @param file the file to get the icon name for
 * @return the icon name for the file, or null if none exists
 */
gchar* plank_drawing_drawing_service_get_icon_from_file (GFile* file) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	{
		GFileInfo* info = NULL;
		GFile* _tmp0_ = NULL;
		GFileInfo* _tmp1_ = NULL;
		const gchar* custom_icon_name = NULL;
		GFileInfo* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		const gchar* _tmp5_ = NULL;
		const gchar* custom_icon = NULL;
		GFileInfo* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		gboolean _tmp11_ = FALSE;
		const gchar* _tmp12_ = NULL;
		const gchar* thumb_icon = NULL;
		GFileInfo* _tmp24_ = NULL;
		const gchar* _tmp25_ = NULL;
		gboolean _tmp26_ = FALSE;
		const gchar* _tmp27_ = NULL;
		GFileInfo* _tmp31_ = NULL;
		GIcon* _tmp32_ = NULL;
		gchar* _tmp33_ = NULL;
		_tmp0_ = file;
		_tmp1_ = g_file_query_info (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_ICON "," PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME "," PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON "," G_FILE_ATTRIBUTE_THUMBNAIL_PATH, 0, NULL, &_inner_error_);
		info = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch13_g_error;
		}
		_tmp2_ = info;
		_tmp3_ = g_file_info_get_attribute_string (_tmp2_, PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME);
		custom_icon_name = _tmp3_;
		_tmp5_ = custom_icon_name;
		if (_tmp5_ != NULL) {
			const gchar* _tmp6_ = NULL;
			_tmp6_ = custom_icon_name;
			_tmp4_ = g_strcmp0 (_tmp6_, "") != 0;
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			const gchar* _tmp7_ = NULL;
			gchar* _tmp8_ = NULL;
			_tmp7_ = custom_icon_name;
			_tmp8_ = g_strdup (_tmp7_);
			result = _tmp8_;
			_g_object_unref0 (info);
			return result;
		}
		_tmp9_ = info;
		_tmp10_ = g_file_info_get_attribute_string (_tmp9_, PLANK_DRAWING_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON);
		custom_icon = _tmp10_;
		_tmp12_ = custom_icon;
		if (_tmp12_ != NULL) {
			const gchar* _tmp13_ = NULL;
			_tmp13_ = custom_icon;
			_tmp11_ = g_strcmp0 (_tmp13_, "") != 0;
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			const gchar* _tmp14_ = NULL;
			gboolean _tmp15_ = FALSE;
			GFile* _tmp18_ = NULL;
			const gchar* _tmp19_ = NULL;
			GFile* _tmp20_ = NULL;
			GFile* _tmp21_ = NULL;
			gchar* _tmp22_ = NULL;
			gchar* _tmp23_ = NULL;
			_tmp14_ = custom_icon;
			_tmp15_ = g_str_has_prefix (_tmp14_, "file://");
			if (_tmp15_) {
				const gchar* _tmp16_ = NULL;
				gchar* _tmp17_ = NULL;
				_tmp16_ = custom_icon;
				_tmp17_ = g_strdup (_tmp16_);
				result = _tmp17_;
				_g_object_unref0 (info);
				return result;
			}
			_tmp18_ = file;
			_tmp19_ = custom_icon;
			_tmp20_ = g_file_get_child (_tmp18_, _tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = g_file_get_path (_tmp21_);
			_tmp23_ = _tmp22_;
			_g_object_unref0 (_tmp21_);
			result = _tmp23_;
			_g_object_unref0 (info);
			return result;
		}
		_tmp24_ = info;
		_tmp25_ = g_file_info_get_attribute_byte_string (_tmp24_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH);
		thumb_icon = _tmp25_;
		_tmp27_ = thumb_icon;
		if (_tmp27_ != NULL) {
			const gchar* _tmp28_ = NULL;
			_tmp28_ = thumb_icon;
			_tmp26_ = g_strcmp0 (_tmp28_, "") != 0;
		} else {
			_tmp26_ = FALSE;
		}
		if (_tmp26_) {
			const gchar* _tmp29_ = NULL;
			gchar* _tmp30_ = NULL;
			_tmp29_ = thumb_icon;
			_tmp30_ = g_strdup (_tmp29_);
			result = _tmp30_;
			_g_object_unref0 (info);
			return result;
		}
		_tmp31_ = info;
		_tmp32_ = g_file_info_get_icon (_tmp31_);
		_tmp33_ = plank_drawing_drawing_service_get_icon_from_gicon (_tmp32_);
		result = _tmp33_;
		_g_object_unref0 (info);
		return result;
	}
	goto __finally13;
	__catch13_g_error:
	{
		gchar* _tmp34_ = NULL;
		GFile* _tmp35_ = NULL;
		gchar* _tmp36_ = NULL;
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
		_tmp35_ = file;
		_tmp36_ = g_file_get_path (_tmp35_);
		_tmp34_ = _tmp36_;
		if (_tmp34_ == NULL) {
			gchar* _tmp37_ = NULL;
			_tmp37_ = g_strdup ("");
			_g_free0 (_tmp34_);
			_tmp34_ = _tmp37_;
		}
		g_debug ("DrawingService.vala:90: Could not get file info for '%s'", _tmp34_);
		_g_free0 (_tmp34_);
	}
	__finally13:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = NULL;
	return result;
}


/**
 * Gets an icon from a {@link GLib.Icon}.
 *
 * @param icon the icon to get the name for
 * @return the icon name, or null if none exists
 */
static gchar* _vala_g_strjoinv (const gchar* separator, gchar** str_array, int str_array_length1) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	_tmp0_ = separator;
	if (_tmp0_ == NULL) {
		separator = "";
	}
	_tmp3_ = str_array;
	_tmp3__length1 = str_array_length1;
	if (_tmp3_ != NULL) {
		_tmp2_ = TRUE;
	} else {
		gchar** _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		_tmp4_ = str_array;
		_tmp4__length1 = str_array_length1;
		_tmp2_ = _tmp4__length1 > 0;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp5_ = FALSE;
		gchar** _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		_tmp6_ = str_array;
		_tmp6__length1 = str_array_length1;
		if (_tmp6__length1 == (-1)) {
			gchar** _tmp7_ = NULL;
			gint _tmp7__length1 = 0;
			const gchar* _tmp8_ = NULL;
			_tmp7_ = str_array;
			_tmp7__length1 = str_array_length1;
			_tmp8_ = _tmp7_[0];
			_tmp5_ = _tmp8_ != NULL;
		} else {
			_tmp5_ = FALSE;
		}
		_tmp1_ = _tmp5_;
	}
	if (_tmp1_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp31_ = 0;
		gint _tmp33_ = 0;
		gint _tmp34_ = 0;
		gsize _tmp35_ = 0UL;
		const gchar* _tmp36_ = NULL;
		gint _tmp37_ = 0;
		gint _tmp38_ = 0;
		gint _tmp39_ = 0;
		const gchar* res = NULL;
		gsize _tmp40_ = 0UL;
		void* _tmp41_ = NULL;
		void* ptr = NULL;
		const gchar* _tmp42_ = NULL;
		gchar** _tmp43_ = NULL;
		gint _tmp43__length1 = 0;
		const gchar* _tmp44_ = NULL;
		void* _tmp45_ = NULL;
		const gchar* _tmp62_ = NULL;
		len = (gsize) 1;
		{
			gboolean _tmp9_ = FALSE;
			i = 0;
			_tmp9_ = TRUE;
			while (TRUE) {
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				gchar** _tmp13_ = NULL;
				gint _tmp13__length1 = 0;
				gint _tmp21_ = 0;
				gchar** _tmp22_ = NULL;
				gint _tmp22__length1 = 0;
				gint _tmp23_ = 0;
				const gchar* _tmp24_ = NULL;
				gsize _tmp30_ = 0UL;
				if (!_tmp9_) {
					gint _tmp10_ = 0;
					_tmp10_ = i;
					i = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				_tmp13_ = str_array;
				_tmp13__length1 = str_array_length1;
				if (_tmp13__length1 != (-1)) {
					gint _tmp14_ = 0;
					gchar** _tmp15_ = NULL;
					gint _tmp15__length1 = 0;
					_tmp14_ = i;
					_tmp15_ = str_array;
					_tmp15__length1 = str_array_length1;
					_tmp12_ = _tmp14_ < _tmp15__length1;
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					_tmp11_ = TRUE;
				} else {
					gboolean _tmp16_ = FALSE;
					gchar** _tmp17_ = NULL;
					gint _tmp17__length1 = 0;
					_tmp17_ = str_array;
					_tmp17__length1 = str_array_length1;
					if (_tmp17__length1 == (-1)) {
						gchar** _tmp18_ = NULL;
						gint _tmp18__length1 = 0;
						gint _tmp19_ = 0;
						const gchar* _tmp20_ = NULL;
						_tmp18_ = str_array;
						_tmp18__length1 = str_array_length1;
						_tmp19_ = i;
						_tmp20_ = _tmp18_[_tmp19_];
						_tmp16_ = _tmp20_ != NULL;
					} else {
						_tmp16_ = FALSE;
					}
					_tmp11_ = _tmp16_;
				}
				if (!_tmp11_) {
					break;
				}
				_tmp22_ = str_array;
				_tmp22__length1 = str_array_length1;
				_tmp23_ = i;
				_tmp24_ = _tmp22_[_tmp23_];
				if (_tmp24_ != NULL) {
					gchar** _tmp25_ = NULL;
					gint _tmp25__length1 = 0;
					gint _tmp26_ = 0;
					const gchar* _tmp27_ = NULL;
					gint _tmp28_ = 0;
					gint _tmp29_ = 0;
					_tmp25_ = str_array;
					_tmp25__length1 = str_array_length1;
					_tmp26_ = i;
					_tmp27_ = _tmp25_[_tmp26_];
					_tmp28_ = strlen ((const gchar*) _tmp27_);
					_tmp29_ = _tmp28_;
					_tmp21_ = _tmp29_;
				} else {
					_tmp21_ = 0;
				}
				_tmp30_ = len;
				len = _tmp30_ + _tmp21_;
			}
		}
		_tmp31_ = i;
		if (_tmp31_ == 0) {
			gchar* _tmp32_ = NULL;
			_tmp32_ = g_strdup ("");
			result = _tmp32_;
			return result;
		}
		_tmp33_ = i;
		str_array_length1 = _tmp33_;
		_tmp34_ = str_array_length1;
		_tmp35_ = len;
		_tmp36_ = separator;
		_tmp37_ = strlen ((const gchar*) _tmp36_);
		_tmp38_ = _tmp37_;
		_tmp39_ = i;
		len = _tmp35_ + (_tmp38_ * (_tmp39_ - 1));
		_tmp40_ = len;
		_tmp41_ = g_malloc (_tmp40_);
		res = _tmp41_;
		_tmp42_ = res;
		_tmp43_ = str_array;
		_tmp43__length1 = str_array_length1;
		_tmp44_ = _tmp43_[0];
		_tmp45_ = g_stpcpy ((void*) _tmp42_, (const gchar*) _tmp44_);
		ptr = _tmp45_;
		{
			gboolean _tmp46_ = FALSE;
			i = 1;
			_tmp46_ = TRUE;
			while (TRUE) {
				gint _tmp48_ = 0;
				gchar** _tmp49_ = NULL;
				gint _tmp49__length1 = 0;
				void* _tmp50_ = NULL;
				const gchar* _tmp51_ = NULL;
				void* _tmp52_ = NULL;
				const gchar* _tmp53_ = NULL;
				gchar** _tmp54_ = NULL;
				gint _tmp54__length1 = 0;
				gint _tmp55_ = 0;
				const gchar* _tmp56_ = NULL;
				void* _tmp60_ = NULL;
				void* _tmp61_ = NULL;
				if (!_tmp46_) {
					gint _tmp47_ = 0;
					_tmp47_ = i;
					i = _tmp47_ + 1;
				}
				_tmp46_ = FALSE;
				_tmp48_ = i;
				_tmp49_ = str_array;
				_tmp49__length1 = str_array_length1;
				if (!(_tmp48_ < _tmp49__length1)) {
					break;
				}
				_tmp50_ = ptr;
				_tmp51_ = separator;
				_tmp52_ = g_stpcpy (_tmp50_, (const gchar*) _tmp51_);
				ptr = _tmp52_;
				_tmp54_ = str_array;
				_tmp54__length1 = str_array_length1;
				_tmp55_ = i;
				_tmp56_ = _tmp54_[_tmp55_];
				if (_tmp56_ != NULL) {
					gchar** _tmp57_ = NULL;
					gint _tmp57__length1 = 0;
					gint _tmp58_ = 0;
					const gchar* _tmp59_ = NULL;
					_tmp57_ = str_array;
					_tmp57__length1 = str_array_length1;
					_tmp58_ = i;
					_tmp59_ = _tmp57_[_tmp58_];
					_tmp53_ = (const gchar*) _tmp59_;
				} else {
					_tmp53_ = "";
				}
				_tmp60_ = ptr;
				_tmp61_ = g_stpcpy (_tmp60_, _tmp53_);
				ptr = _tmp61_;
			}
		}
		_tmp62_ = res;
		res = NULL;
		result = (gchar*) _tmp62_;
		return result;
	} else {
		gchar* _tmp63_ = NULL;
		_tmp63_ = g_strdup ("");
		result = _tmp63_;
		return result;
	}
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch14_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch14_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally14;
	__catch14_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally14:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar* plank_drawing_drawing_service_get_icon_from_gicon (GIcon* icon) {
	gchar* result = NULL;
	GIcon* _tmp0_ = NULL;
	GIcon* _tmp7_ = NULL;
	_tmp0_ = icon;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_themed_icon_get_type ())) {
		gchar* icons = NULL;
		GIcon* _tmp1_ = NULL;
		gchar** _tmp2_ = NULL;
		gchar** _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp1_ = icon;
		_tmp3_ = _tmp2_ = g_themed_icon_get_names (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_themed_icon_get_type (), GThemedIcon));
		_tmp4_ = _vala_g_strjoinv (";;", _tmp3_, _vala_array_length (_tmp2_));
		icons = _tmp4_;
		_tmp5_ = icons;
		_tmp6_ = string_replace (_tmp5_, "(null);;", "");
		result = _tmp6_;
		_g_free0 (icons);
		return result;
	}
	_tmp7_ = icon;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, g_file_icon_get_type ())) {
		GIcon* _tmp8_ = NULL;
		GFile* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		_tmp8_ = icon;
		_tmp9_ = g_file_icon_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_file_icon_get_type (), GFileIcon));
		_tmp10_ = g_file_get_path (_tmp9_);
		result = _tmp10_;
		return result;
	}
	result = NULL;
	return result;
}


/**
 * Loads an icon based on names and the given width/height
 *
 * @param names a delimited (with ";;") list of icon names, first one found is used
 * @param width the requested width of the icon
 * @param height the requested height of the icon
 * @return the pixbuf representing the requested icon
 */
static void _vala_array_add3 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


GdkPixbuf* plank_drawing_drawing_service_load_icon (const gchar* names, gint width, gint height) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	gchar** all_names = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint all_names_length1 = 0;
	gint _all_names_size_ = 0;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	gchar* _tmp4_ = NULL;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	GdkPixbuf* _tmp22_ = NULL;
	GdkPixbuf* _tmp26_ = NULL;
	gint _tmp44_ = 0;
	gint _tmp45_ = 0;
	gint _tmp46_ = 0;
	gint _tmp47_ = 0;
	GdkPixbuf* _tmp48_ = NULL;
	g_return_val_if_fail (names != NULL, NULL);
	pbuf = NULL;
	_tmp0_ = names;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ";;", 0);
	all_names = _tmp2_;
	all_names_length1 = _vala_array_length (_tmp1_);
	_all_names_size_ = all_names_length1;
	_tmp3_ = all_names;
	_tmp3__length1 = all_names_length1;
	_tmp4_ = g_strdup (PLANK_DRAWING_DRAWING_SERVICE_DEFAULT_ICON);
	_vala_array_add3 (&all_names, &all_names_length1, &_all_names_size_, _tmp4_);
	_tmp5_ = all_names;
	_tmp5__length1 = all_names_length1;
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
		name_collection = _tmp5_;
		name_collection_length1 = _tmp5__length1;
		for (name_it = 0; name_it < _tmp5__length1; name_it = name_it + 1) {
			const gchar* name = NULL;
			name = name_collection[name_it];
			{
				GFile* file = NULL;
				const gchar* _tmp6_ = NULL;
				GFile* _tmp7_ = NULL;
				GFile* _tmp8_ = NULL;
				const gchar* _tmp14_ = NULL;
				gint _tmp15_ = 0;
				gint _tmp16_ = 0;
				gint _tmp17_ = 0;
				GdkPixbuf* _tmp18_ = NULL;
				GdkPixbuf* _tmp19_ = NULL;
				const gchar* _tmp20_ = NULL;
				_tmp6_ = name;
				_tmp7_ = plank_drawing_drawing_service_try_get_icon_file (_tmp6_);
				file = _tmp7_;
				_tmp8_ = file;
				if (_tmp8_ != NULL) {
					GFile* _tmp9_ = NULL;
					gint _tmp10_ = 0;
					gint _tmp11_ = 0;
					GdkPixbuf* _tmp12_ = NULL;
					GdkPixbuf* _tmp13_ = NULL;
					_tmp9_ = file;
					_tmp10_ = width;
					_tmp11_ = height;
					_tmp12_ = plank_drawing_drawing_service_load_pixbuf_from_file (_tmp9_, _tmp10_, _tmp11_);
					_g_object_unref0 (pbuf);
					pbuf = _tmp12_;
					_tmp13_ = pbuf;
					if (_tmp13_ != NULL) {
						_g_object_unref0 (file);
						break;
					}
				}
				_tmp14_ = name;
				_tmp15_ = width;
				_tmp16_ = height;
				_tmp17_ = MAX (_tmp15_, _tmp16_);
				_tmp18_ = plank_drawing_drawing_service_load_pixbuf (_tmp14_, _tmp17_);
				_g_object_unref0 (pbuf);
				pbuf = _tmp18_;
				_tmp19_ = pbuf;
				if (_tmp19_ != NULL) {
					_g_object_unref0 (file);
					break;
				}
				_tmp20_ = name;
				if (g_strcmp0 (_tmp20_, PLANK_DRAWING_DRAWING_SERVICE_DEFAULT_ICON) != 0) {
					const gchar* _tmp21_ = NULL;
					_tmp21_ = name;
					g_message ("DrawingService.vala:144: Could not find icon '%s'", _tmp21_);
				}
				_g_object_unref0 (file);
			}
		}
	}
	_tmp22_ = pbuf;
	if (_tmp22_ == NULL) {
		gint _tmp23_ = 0;
		gint _tmp24_ = 0;
		GdkPixbuf* _tmp25_ = NULL;
		_tmp23_ = width;
		_tmp24_ = height;
		_tmp25_ = plank_drawing_drawing_service_load_pixbuf_from_resource (PLANK_G_RESOURCE_PATH "/img/application-default-icon.svg", _tmp23_, _tmp24_);
		_g_object_unref0 (pbuf);
		pbuf = _tmp25_;
	}
	_tmp26_ = pbuf;
	if (_tmp26_ != NULL) {
		gboolean _tmp27_ = FALSE;
		gboolean _tmp28_ = FALSE;
		gint _tmp29_ = 0;
		_tmp29_ = width;
		if (_tmp29_ != (-1)) {
			gint _tmp30_ = 0;
			_tmp30_ = height;
			_tmp28_ = _tmp30_ != (-1);
		} else {
			_tmp28_ = FALSE;
		}
		if (_tmp28_) {
			gboolean _tmp31_ = FALSE;
			gint _tmp32_ = 0;
			GdkPixbuf* _tmp33_ = NULL;
			gint _tmp34_ = 0;
			gint _tmp35_ = 0;
			_tmp32_ = width;
			_tmp33_ = pbuf;
			_tmp34_ = gdk_pixbuf_get_width (_tmp33_);
			_tmp35_ = _tmp34_;
			if (_tmp32_ != _tmp35_) {
				_tmp31_ = TRUE;
			} else {
				gint _tmp36_ = 0;
				GdkPixbuf* _tmp37_ = NULL;
				gint _tmp38_ = 0;
				gint _tmp39_ = 0;
				_tmp36_ = height;
				_tmp37_ = pbuf;
				_tmp38_ = gdk_pixbuf_get_height (_tmp37_);
				_tmp39_ = _tmp38_;
				_tmp31_ = _tmp36_ != _tmp39_;
			}
			_tmp27_ = _tmp31_;
		} else {
			_tmp27_ = FALSE;
		}
		if (_tmp27_) {
			GdkPixbuf* _tmp40_ = NULL;
			gint _tmp41_ = 0;
			gint _tmp42_ = 0;
			GdkPixbuf* _tmp43_ = NULL;
			_tmp40_ = pbuf;
			_tmp41_ = width;
			_tmp42_ = height;
			_tmp43_ = plank_drawing_drawing_service_ar_scale (_tmp40_, _tmp41_, _tmp42_);
			result = _tmp43_;
			all_names = (_vala_array_free (all_names, all_names_length1, (GDestroyNotify) g_free), NULL);
			_g_object_unref0 (pbuf);
			return result;
		}
		result = pbuf;
		all_names = (_vala_array_free (all_names, all_names_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	g_warning ("DrawingService.vala:157: No icon found, return empty pixbuf");
	_tmp44_ = width;
	_tmp45_ = MAX (1, _tmp44_);
	_tmp46_ = height;
	_tmp47_ = MAX (1, _tmp46_);
	_tmp48_ = plank_drawing_drawing_service_get_empty_pixbuf (_tmp45_, _tmp47_);
	result = _tmp48_;
	all_names = (_vala_array_free (all_names, all_names_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (pbuf);
	return result;
}


static GdkPixbuf* plank_drawing_drawing_service_get_empty_pixbuf (gint width, gint height) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GdkPixbuf* _tmp2_ = NULL;
	_tmp0_ = width;
	_tmp1_ = height;
	_tmp2_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, _tmp0_, _tmp1_);
	pbuf = _tmp2_;
	gdk_pixbuf_fill (pbuf, (guint32) 0x00000000);
	result = pbuf;
	return result;
}


/**
 * Try to get a {@link GLib.File} for the given icon name
 *
 * @param name a string which might represent an existing file
 * @return a {@link GLib.File}, or null if it failed
 */
GFile* plank_drawing_drawing_service_try_get_icon_file (const gchar* name) {
	GFile* result = NULL;
	GFile* file = NULL;
	gchar* name_down = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp21_ = FALSE;
	GFile* _tmp22_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	file = NULL;
	_tmp0_ = name;
	_tmp1_ = g_utf8_strdown (_tmp0_, (gssize) (-1));
	name_down = _tmp1_;
	_tmp2_ = name_down;
	_tmp3_ = g_str_has_prefix (_tmp2_, "resource://");
	if (_tmp3_) {
		const gchar* _tmp4_ = NULL;
		GFile* _tmp5_ = NULL;
		_tmp4_ = name;
		_tmp5_ = g_file_new_for_uri (_tmp4_);
		_g_object_unref0 (file);
		file = _tmp5_;
	} else {
		const gchar* _tmp6_ = NULL;
		gboolean _tmp7_ = FALSE;
		_tmp6_ = name_down;
		_tmp7_ = g_str_has_prefix (_tmp6_, "file://");
		if (_tmp7_) {
			const gchar* _tmp8_ = NULL;
			GFile* _tmp9_ = NULL;
			_tmp8_ = name;
			_tmp9_ = g_file_new_for_uri (_tmp8_);
			_g_object_unref0 (file);
			file = _tmp9_;
		} else {
			const gchar* _tmp10_ = NULL;
			gboolean _tmp11_ = FALSE;
			_tmp10_ = name;
			_tmp11_ = g_str_has_prefix (_tmp10_, "~/");
			if (_tmp11_) {
				const gchar* _tmp12_ = NULL;
				const gchar* _tmp13_ = NULL;
				gchar* _tmp14_ = NULL;
				gchar* _tmp15_ = NULL;
				GFile* _tmp16_ = NULL;
				_tmp12_ = name;
				_tmp13_ = g_get_home_dir ();
				_tmp14_ = string_replace (_tmp12_, "~", _tmp13_);
				_tmp15_ = _tmp14_;
				_tmp16_ = g_file_new_for_path (_tmp15_);
				_g_object_unref0 (file);
				file = _tmp16_;
				_g_free0 (_tmp15_);
			} else {
				const gchar* _tmp17_ = NULL;
				gboolean _tmp18_ = FALSE;
				_tmp17_ = name;
				_tmp18_ = g_str_has_prefix (_tmp17_, "/");
				if (_tmp18_) {
					const gchar* _tmp19_ = NULL;
					GFile* _tmp20_ = NULL;
					_tmp19_ = name;
					_tmp20_ = g_file_new_for_path (_tmp19_);
					_g_object_unref0 (file);
					file = _tmp20_;
				}
			}
		}
	}
	_tmp22_ = file;
	if (_tmp22_ != NULL) {
		GFile* _tmp23_ = NULL;
		gboolean _tmp24_ = FALSE;
		_tmp23_ = file;
		_tmp24_ = g_file_query_exists (_tmp23_, NULL);
		_tmp21_ = _tmp24_;
	} else {
		_tmp21_ = FALSE;
	}
	if (_tmp21_) {
		result = file;
		_g_free0 (name_down);
		return result;
	}
	result = NULL;
	_g_free0 (name_down);
	_g_object_unref0 (file);
	return result;
}


static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf_from_file (GFile* file, gint width, gint height) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	pbuf = NULL;
	{
		GFileInputStream* fis = NULL;
		GFile* _tmp0_ = NULL;
		GFileInputStream* _tmp1_ = NULL;
		GdkPixbuf* _tmp2_ = NULL;
		GFileInputStream* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		GdkPixbuf* _tmp6_ = NULL;
		GdkPixbuf* _tmp7_ = NULL;
		_tmp0_ = file;
		_tmp1_ = g_file_read (_tmp0_, NULL, &_inner_error_);
		fis = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch15_g_error;
		}
		_tmp3_ = fis;
		_tmp4_ = width;
		_tmp5_ = height;
		_tmp6_ = gdk_pixbuf_new_from_stream_at_scale ((GInputStream*) _tmp3_, _tmp4_, _tmp5_, TRUE, NULL, &_inner_error_);
		_tmp2_ = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (fis);
			goto __catch15_g_error;
		}
		_tmp7_ = _tmp2_;
		_tmp2_ = NULL;
		_g_object_unref0 (pbuf);
		pbuf = _tmp7_;
		_g_object_unref0 (_tmp2_);
		_g_object_unref0 (fis);
	}
	goto __finally15;
	__catch15_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally15:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = pbuf;
	return result;
}


static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf_from_resource (const gchar* resource, gint width, gint height) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (resource != NULL, NULL);
	pbuf = NULL;
	{
		GdkPixbuf* _tmp0_ = NULL;
		const gchar* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		GdkPixbuf* _tmp4_ = NULL;
		GdkPixbuf* _tmp5_ = NULL;
		_tmp1_ = resource;
		_tmp2_ = width;
		_tmp3_ = height;
		_tmp4_ = gdk_pixbuf_new_from_resource_at_scale (_tmp1_, _tmp2_, _tmp3_, TRUE, &_inner_error_);
		_tmp0_ = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch16_g_error;
		}
		_tmp5_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (pbuf);
		pbuf = _tmp5_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally16;
	__catch16_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally16:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = pbuf;
	return result;
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static GdkPixbuf* plank_drawing_drawing_service_load_pixbuf (const gchar* icon, gint size) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (icon != NULL, NULL);
	pbuf = NULL;
	_tmp0_ = plank_drawing_drawing_service_get_icon_theme ();
	icon_theme = _tmp0_;
	g_mutex_lock (&plank_drawing_drawing_service_icon_theme_mutex);
	{
		GdkPixbuf* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		GdkPixbuf* _tmp4_ = NULL;
		GdkPixbuf* _tmp5_ = NULL;
		_tmp2_ = icon;
		_tmp3_ = size;
		_tmp4_ = gtk_icon_theme_load_icon (icon_theme, _tmp2_, _tmp3_, 0, &_inner_error_);
		_tmp1_ = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch17_g_error;
		}
		_tmp5_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (pbuf);
		pbuf = _tmp5_;
		_g_object_unref0 (_tmp1_);
	}
	goto __finally17;
	__catch17_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally17:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	{
		gboolean _tmp6_ = FALSE;
		GdkPixbuf* _tmp7_ = NULL;
		_tmp7_ = pbuf;
		if (_tmp7_ == NULL) {
			const gchar* _tmp8_ = NULL;
			gboolean _tmp9_ = FALSE;
			_tmp8_ = icon;
			_tmp9_ = string_contains (_tmp8_, ".");
			_tmp6_ = _tmp9_;
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			gchar** parts = NULL;
			const gchar* _tmp10_ = NULL;
			gchar** _tmp11_ = NULL;
			gchar** _tmp12_ = NULL;
			gint parts_length1 = 0;
			gint _parts_size_ = 0;
			GdkPixbuf* _tmp13_ = NULL;
			gchar** _tmp14_ = NULL;
			gint _tmp14__length1 = 0;
			const gchar* _tmp15_ = NULL;
			gint _tmp16_ = 0;
			GdkPixbuf* _tmp17_ = NULL;
			GdkPixbuf* _tmp18_ = NULL;
			_tmp10_ = icon;
			_tmp12_ = _tmp11_ = g_strsplit (_tmp10_, ".", 0);
			parts = _tmp12_;
			parts_length1 = _vala_array_length (_tmp11_);
			_parts_size_ = parts_length1;
			_tmp14_ = parts;
			_tmp14__length1 = parts_length1;
			_tmp15_ = _tmp14_[0];
			_tmp16_ = size;
			_tmp17_ = gtk_icon_theme_load_icon (icon_theme, _tmp15_, _tmp16_, 0, &_inner_error_);
			_tmp13_ = _tmp17_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
				goto __catch18_g_error;
			}
			_tmp18_ = _tmp13_;
			_tmp13_ = NULL;
			_g_object_unref0 (pbuf);
			pbuf = _tmp18_;
			_g_object_unref0 (_tmp13_);
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
		}
	}
	goto __finally18;
	__catch18_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally18:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	g_mutex_unlock (&plank_drawing_drawing_service_icon_theme_mutex);
	result = pbuf;
	return result;
}


/**
 * Loads an icon based on names and the given width/height
 *
 * @param names a delimited (with ";;") list of icon names, first one found is used
 * @param width the requested width of the icon
 * @param height the requested height of the icon
 * @param scale the implicit requested scale of the icon
 * @return the {link Cairo.Surface} containing the requested icon, do not alter this surface
 */
static void _vala_array_add4 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


cairo_surface_t* plank_drawing_drawing_service_load_icon_for_scale (const gchar* names, gint width, gint height, gint scale) {
	cairo_surface_t* result = NULL;
	cairo_surface_t* surface = NULL;
	gchar** all_names = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint all_names_length1 = 0;
	gint _all_names_size_ = 0;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	gchar* _tmp4_ = NULL;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	cairo_surface_t* _tmp43_ = NULL;
	g_return_val_if_fail (names != NULL, NULL);
	surface = NULL;
	_tmp0_ = names;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ";;", 0);
	all_names = _tmp2_;
	all_names_length1 = _vala_array_length (_tmp1_);
	_all_names_size_ = all_names_length1;
	_tmp3_ = all_names;
	_tmp3__length1 = all_names_length1;
	_tmp4_ = g_strdup (PLANK_DRAWING_DRAWING_SERVICE_DEFAULT_ICON);
	_vala_array_add4 (&all_names, &all_names_length1, &_all_names_size_, _tmp4_);
	_tmp5_ = all_names;
	_tmp5__length1 = all_names_length1;
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
		name_collection = _tmp5_;
		name_collection_length1 = _tmp5__length1;
		for (name_it = 0; name_it < _tmp5__length1; name_it = name_it + 1) {
			const gchar* name = NULL;
			name = name_collection[name_it];
			{
				GFile* file = NULL;
				const gchar* _tmp6_ = NULL;
				GFile* _tmp7_ = NULL;
				GFile* _tmp8_ = NULL;
				const gchar* _tmp33_ = NULL;
				gint _tmp34_ = 0;
				gint _tmp35_ = 0;
				gint _tmp36_ = 0;
				gint _tmp37_ = 0;
				gint _tmp38_ = 0;
				cairo_surface_t* _tmp39_ = NULL;
				cairo_surface_t* _tmp40_ = NULL;
				const gchar* _tmp41_ = NULL;
				_tmp6_ = name;
				_tmp7_ = plank_drawing_drawing_service_try_get_icon_file (_tmp6_);
				file = _tmp7_;
				_tmp8_ = file;
				if (_tmp8_ != NULL) {
					GdkPixbuf* pbuf = NULL;
					GFile* _tmp9_ = NULL;
					gint _tmp10_ = 0;
					gint _tmp11_ = 0;
					GdkPixbuf* _tmp12_ = NULL;
					GdkPixbuf* _tmp13_ = NULL;
					_tmp9_ = file;
					_tmp10_ = width;
					_tmp11_ = height;
					_tmp12_ = plank_drawing_drawing_service_load_pixbuf_from_file (_tmp9_, _tmp10_, _tmp11_);
					pbuf = _tmp12_;
					_tmp13_ = pbuf;
					if (_tmp13_ != NULL) {
						gint _tmp14_ = 0;
						gint _tmp15_ = 0;
						cairo_surface_t* _tmp16_ = NULL;
						cairo_t* cr = NULL;
						cairo_surface_t* _tmp17_ = NULL;
						cairo_t* _tmp18_ = NULL;
						cairo_t* _tmp19_ = NULL;
						GdkPixbuf* _tmp20_ = NULL;
						gint _tmp21_ = 0;
						GdkPixbuf* _tmp22_ = NULL;
						gint _tmp23_ = 0;
						gint _tmp24_ = 0;
						gint _tmp25_ = 0;
						GdkPixbuf* _tmp26_ = NULL;
						gint _tmp27_ = 0;
						gint _tmp28_ = 0;
						cairo_t* _tmp29_ = NULL;
						cairo_surface_t* _tmp30_ = NULL;
						gint _tmp31_ = 0;
						gint _tmp32_ = 0;
						_tmp14_ = width;
						_tmp15_ = height;
						_tmp16_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp14_, _tmp15_);
						_cairo_surface_destroy0 (surface);
						surface = _tmp16_;
						_tmp17_ = surface;
						_tmp18_ = cairo_create (_tmp17_);
						cr = _tmp18_;
						_tmp19_ = cr;
						_tmp20_ = pbuf;
						_tmp21_ = width;
						_tmp22_ = pbuf;
						_tmp23_ = gdk_pixbuf_get_width (_tmp22_);
						_tmp24_ = _tmp23_;
						_tmp25_ = height;
						_tmp26_ = pbuf;
						_tmp27_ = gdk_pixbuf_get_height (_tmp26_);
						_tmp28_ = _tmp27_;
						gdk_cairo_set_source_pixbuf (_tmp19_, _tmp20_, (gdouble) ((_tmp21_ - _tmp24_) / 2), (gdouble) ((_tmp25_ - _tmp28_) / 2));
						_tmp29_ = cr;
						cairo_paint (_tmp29_);
						_tmp30_ = surface;
						_tmp31_ = scale;
						_tmp32_ = scale;
						cairo_surface_set_device_scale (_tmp30_, (gdouble) _tmp31_, (gdouble) _tmp32_);
						_cairo_destroy0 (cr);
						_g_object_unref0 (pbuf);
						_g_object_unref0 (file);
						break;
					}
					_g_object_unref0 (pbuf);
				}
				_tmp33_ = name;
				_tmp34_ = width;
				_tmp35_ = height;
				_tmp36_ = MAX (_tmp34_, _tmp35_);
				_tmp37_ = scale;
				_tmp38_ = scale;
				_tmp39_ = plank_drawing_drawing_service_load_surface (_tmp33_, _tmp36_ / _tmp37_, _tmp38_);
				_cairo_surface_destroy0 (surface);
				surface = _tmp39_;
				_tmp40_ = surface;
				if (_tmp40_ != NULL) {
					_g_object_unref0 (file);
					break;
				}
				_tmp41_ = name;
				if (g_strcmp0 (_tmp41_, PLANK_DRAWING_DRAWING_SERVICE_DEFAULT_ICON) != 0) {
					const gchar* _tmp42_ = NULL;
					_tmp42_ = name;
					g_message ("DrawingService.vala:277: Could not find icon '%s'", _tmp42_);
				}
				_g_object_unref0 (file);
			}
		}
	}
	_tmp43_ = surface;
	if (_tmp43_ == NULL) {
		gint _tmp44_ = 0;
		gint _tmp45_ = 0;
		gint _tmp46_ = 0;
		cairo_surface_t* _tmp47_ = NULL;
		_tmp44_ = width;
		_tmp45_ = height;
		_tmp46_ = scale;
		_tmp47_ = plank_drawing_drawing_service_load_surface_from_resource_at_scale (PLANK_G_RESOURCE_PATH "/img/application-default-icon.svg", _tmp44_, _tmp45_, _tmp46_);
		_cairo_surface_destroy0 (surface);
		surface = _tmp47_;
	}
	result = surface;
	all_names = (_vala_array_free (all_names, all_names_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static cairo_surface_t* plank_drawing_drawing_service_load_surface_from_resource_at_scale (const gchar* resource, gint width, gint height, gint scale) {
	cairo_surface_t* result = NULL;
	GdkPixbuf* pbuf = NULL;
	cairo_surface_t* surface = NULL;
	GdkPixbuf* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (resource != NULL, NULL);
	pbuf = NULL;
	surface = NULL;
	{
		GdkPixbuf* _tmp0_ = NULL;
		const gchar* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		GdkPixbuf* _tmp4_ = NULL;
		GdkPixbuf* _tmp5_ = NULL;
		_tmp1_ = resource;
		_tmp2_ = width;
		_tmp3_ = height;
		_tmp4_ = gdk_pixbuf_new_from_resource_at_scale (_tmp1_, _tmp2_, _tmp3_, TRUE, &_inner_error_);
		_tmp0_ = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch19_g_error;
		}
		_tmp5_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (pbuf);
		pbuf = _tmp5_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally19;
	__catch19_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally19:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_cairo_surface_destroy0 (surface);
		_g_object_unref0 (pbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp6_ = pbuf;
	if (_tmp6_ != NULL) {
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		cairo_surface_t* _tmp9_ = NULL;
		cairo_t* cr = NULL;
		cairo_surface_t* _tmp10_ = NULL;
		cairo_t* _tmp11_ = NULL;
		cairo_t* _tmp12_ = NULL;
		GdkPixbuf* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		GdkPixbuf* _tmp15_ = NULL;
		gint _tmp16_ = 0;
		gint _tmp17_ = 0;
		gint _tmp18_ = 0;
		GdkPixbuf* _tmp19_ = NULL;
		gint _tmp20_ = 0;
		gint _tmp21_ = 0;
		cairo_t* _tmp22_ = NULL;
		cairo_surface_t* _tmp23_ = NULL;
		gint _tmp24_ = 0;
		gint _tmp25_ = 0;
		_tmp7_ = width;
		_tmp8_ = height;
		_tmp9_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp7_, _tmp8_);
		_cairo_surface_destroy0 (surface);
		surface = _tmp9_;
		_tmp10_ = surface;
		_tmp11_ = cairo_create (_tmp10_);
		cr = _tmp11_;
		_tmp12_ = cr;
		_tmp13_ = pbuf;
		_tmp14_ = width;
		_tmp15_ = pbuf;
		_tmp16_ = gdk_pixbuf_get_width (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = height;
		_tmp19_ = pbuf;
		_tmp20_ = gdk_pixbuf_get_height (_tmp19_);
		_tmp21_ = _tmp20_;
		gdk_cairo_set_source_pixbuf (_tmp12_, _tmp13_, (gdouble) ((_tmp14_ - _tmp17_) / 2), (gdouble) ((_tmp18_ - _tmp21_) / 2));
		_tmp22_ = cr;
		cairo_paint (_tmp22_);
		_tmp23_ = surface;
		_tmp24_ = scale;
		_tmp25_ = scale;
		cairo_surface_set_device_scale (_tmp23_, (gdouble) _tmp24_, (gdouble) _tmp25_);
		_cairo_destroy0 (cr);
	}
	result = surface;
	_g_object_unref0 (pbuf);
	return result;
}


static cairo_surface_t* plank_drawing_drawing_service_load_surface (const gchar* icon, gint size, gint scale) {
	cairo_surface_t* result = NULL;
	cairo_surface_t* surface = NULL;
	GtkIconInfo* info = NULL;
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (icon != NULL, NULL);
	surface = NULL;
	info = NULL;
	_tmp0_ = plank_drawing_drawing_service_get_icon_theme ();
	icon_theme = _tmp0_;
	g_mutex_lock (&plank_drawing_drawing_service_icon_theme_mutex);
	{
		GtkIconTheme* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		GtkIconInfo* _tmp5_ = NULL;
		GtkIconInfo* _tmp6_ = NULL;
		_tmp1_ = icon_theme;
		_tmp2_ = icon;
		_tmp3_ = size;
		_tmp4_ = scale;
		_tmp5_ = gtk_icon_theme_lookup_icon_for_scale (_tmp1_, _tmp2_, _tmp3_, _tmp4_, GTK_ICON_LOOKUP_FORCE_SIZE);
		_gtk_icon_info_free0 (info);
		info = _tmp5_;
		_tmp6_ = info;
		if (_tmp6_ != NULL) {
			cairo_surface_t* _tmp7_ = NULL;
			GtkIconInfo* _tmp8_ = NULL;
			cairo_surface_t* _tmp9_ = NULL;
			cairo_surface_t* _tmp10_ = NULL;
			_tmp8_ = info;
			_tmp9_ = gtk_icon_info_load_surface (_tmp8_, NULL, &_inner_error_);
			_tmp7_ = _tmp9_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch20_g_error;
			}
			_tmp10_ = _tmp7_;
			_tmp7_ = NULL;
			_cairo_surface_destroy0 (surface);
			surface = _tmp10_;
			_cairo_surface_destroy0 (_tmp7_);
		}
	}
	goto __finally20;
	__catch20_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally20:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_gtk_icon_info_free0 (info);
		_cairo_surface_destroy0 (surface);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	{
		gboolean _tmp11_ = FALSE;
		cairo_surface_t* _tmp12_ = NULL;
		_tmp12_ = surface;
		if (_tmp12_ == NULL) {
			const gchar* _tmp13_ = NULL;
			gboolean _tmp14_ = FALSE;
			_tmp13_ = icon;
			_tmp14_ = string_contains (_tmp13_, ".");
			_tmp11_ = _tmp14_;
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			gchar** parts = NULL;
			const gchar* _tmp15_ = NULL;
			gchar** _tmp16_ = NULL;
			gchar** _tmp17_ = NULL;
			gint parts_length1 = 0;
			gint _parts_size_ = 0;
			GtkIconTheme* _tmp18_ = NULL;
			gchar** _tmp19_ = NULL;
			gint _tmp19__length1 = 0;
			const gchar* _tmp20_ = NULL;
			gint _tmp21_ = 0;
			gint _tmp22_ = 0;
			GtkIconInfo* _tmp23_ = NULL;
			GtkIconInfo* _tmp24_ = NULL;
			_tmp15_ = icon;
			_tmp17_ = _tmp16_ = g_strsplit (_tmp15_, ".", 0);
			parts = _tmp17_;
			parts_length1 = _vala_array_length (_tmp16_);
			_parts_size_ = parts_length1;
			_tmp18_ = icon_theme;
			_tmp19_ = parts;
			_tmp19__length1 = parts_length1;
			_tmp20_ = _tmp19_[0];
			_tmp21_ = size;
			_tmp22_ = scale;
			_tmp23_ = gtk_icon_theme_lookup_icon_for_scale (_tmp18_, _tmp20_, _tmp21_, _tmp22_, GTK_ICON_LOOKUP_FORCE_SIZE);
			_gtk_icon_info_free0 (info);
			info = _tmp23_;
			_tmp24_ = info;
			if (_tmp24_ != NULL) {
				cairo_surface_t* _tmp25_ = NULL;
				GtkIconInfo* _tmp26_ = NULL;
				cairo_surface_t* _tmp27_ = NULL;
				cairo_surface_t* _tmp28_ = NULL;
				_tmp26_ = info;
				_tmp27_ = gtk_icon_info_load_surface (_tmp26_, NULL, &_inner_error_);
				_tmp25_ = _tmp27_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
					goto __catch21_g_error;
				}
				_tmp28_ = _tmp25_;
				_tmp25_ = NULL;
				_cairo_surface_destroy0 (surface);
				surface = _tmp28_;
				_cairo_surface_destroy0 (_tmp25_);
			}
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
		}
	}
	goto __finally21;
	__catch21_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally21:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_gtk_icon_info_free0 (info);
		_cairo_surface_destroy0 (surface);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	g_mutex_unlock (&plank_drawing_drawing_service_icon_theme_mutex);
	result = surface;
	_gtk_icon_info_free0 (info);
	return result;
}


/**
 * Scales a {@link Gdk.Pixbuf}, maintaining the original aspect ratio.
 *
 * @param source the pixbuf to scale
 * @param width the width of the scaled pixbuf
 * @param height the height of the scaled pixbuf
 * @return the scaled pixbuf
 */
GdkPixbuf* plank_drawing_drawing_service_ar_scale (GdkPixbuf* source, gint width, gint height) {
	GdkPixbuf* result = NULL;
	gdouble source_width = 0.0;
	GdkPixbuf* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gdouble source_height = 0.0;
	GdkPixbuf* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gdouble x_scale = 0.0;
	gint _tmp6_ = 0;
	gdouble _tmp7_ = 0.0;
	gdouble y_scale = 0.0;
	gint _tmp8_ = 0;
	gdouble _tmp9_ = 0.0;
	gdouble scale = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gint scaled_width = 0;
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	gint _tmp18_ = 0;
	gint scaled_height = 0;
	gdouble _tmp19_ = 0.0;
	gdouble _tmp20_ = 0.0;
	gint _tmp21_ = 0;
	GdkPixbuf* _tmp22_ = NULL;
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	GdkPixbuf* _tmp25_ = NULL;
	g_return_val_if_fail (source != NULL, NULL);
	_tmp0_ = source;
	_tmp1_ = gdk_pixbuf_get_width (_tmp0_);
	_tmp2_ = _tmp1_;
	source_width = (gdouble) _tmp2_;
	_tmp3_ = source;
	_tmp4_ = gdk_pixbuf_get_height (_tmp3_);
	_tmp5_ = _tmp4_;
	source_height = (gdouble) _tmp5_;
	_tmp6_ = width;
	_tmp7_ = source_width;
	x_scale = _tmp6_ / _tmp7_;
	_tmp8_ = height;
	_tmp9_ = source_height;
	y_scale = _tmp8_ / _tmp9_;
	_tmp10_ = x_scale;
	_tmp11_ = y_scale;
	_tmp12_ = MIN (_tmp10_, _tmp11_);
	scale = _tmp12_;
	_tmp13_ = scale;
	if (_tmp13_ == ((gdouble) 1)) {
		GdkPixbuf* _tmp14_ = NULL;
		GdkPixbuf* _tmp15_ = NULL;
		_tmp14_ = source;
		_tmp15_ = _g_object_ref0 (_tmp14_);
		result = _tmp15_;
		return result;
	}
	_tmp16_ = source_width;
	_tmp17_ = scale;
	_tmp18_ = MAX (1, (gint) (_tmp16_ * _tmp17_));
	scaled_width = _tmp18_;
	_tmp19_ = source_height;
	_tmp20_ = scale;
	_tmp21_ = MAX (1, (gint) (_tmp19_ * _tmp20_));
	scaled_height = _tmp21_;
	_tmp22_ = source;
	_tmp23_ = scaled_width;
	_tmp24_ = scaled_height;
	_tmp25_ = gdk_pixbuf_scale_simple (_tmp22_, _tmp23_, _tmp24_, GDK_INTERP_HYPER);
	result = _tmp25_;
	return result;
}


/**
 * Computes and returns the average color of a {@link Gdk.Pixbuf}.
 * The resulting color is the average of all pixels which aren't
 * nearly transparent while saturated pixels are weighted more than
 * "grey" ones.
 *
 * @param source the pixbuf to use
 * @return the average color of the pixbuf
 */
void plank_drawing_drawing_service_average_color (GdkPixbuf* source, PlankDrawingColor* result) {
	guint8 r = 0U;
	guint8 g = 0U;
	guint8 b = 0U;
	guint8 a = 0U;
	guint8 min = 0U;
	guint8 max = 0U;
	gdouble delta = 0.0;
	gdouble rTotal = 0.0;
	gdouble gTotal = 0.0;
	gdouble bTotal = 0.0;
	gdouble bTotal2 = 0.0;
	gdouble gTotal2 = 0.0;
	gdouble rTotal2 = 0.0;
	gdouble aTotal2 = 0.0;
	guint8* dataPtr = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	guint8* _tmp1_ = NULL;
	gint n_channels = 0;
	GdkPixbuf* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint width = 0;
	GdkPixbuf* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gint height = 0;
	GdkPixbuf* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gint rowstride = 0;
	GdkPixbuf* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	gint length = 0;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	gint pixels = 0;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gdouble scoreTotal = 0.0;
	gint _tmp75_ = 0;
	gdouble _tmp77_ = 0.0;
	gint _tmp78_ = 0;
	gdouble _tmp79_ = 0.0;
	gint _tmp80_ = 0;
	gdouble _tmp81_ = 0.0;
	gint _tmp82_ = 0;
	gdouble _tmp83_ = 0.0;
	gint _tmp84_ = 0;
	gdouble _tmp85_ = 0.0;
	gdouble _tmp92_ = 0.0;
	gint _tmp93_ = 0;
	gdouble _tmp94_ = 0.0;
	gint _tmp95_ = 0;
	gdouble _tmp96_ = 0.0;
	gint _tmp97_ = 0;
	gdouble _tmp98_ = 0.0;
	gint _tmp99_ = 0;
	gdouble _tmp100_ = 0.0;
	gdouble max_val = 0.0;
	gdouble _tmp115_ = 0.0;
	gdouble _tmp116_ = 0.0;
	gdouble _tmp117_ = 0.0;
	gdouble _tmp118_ = 0.0;
	gdouble _tmp119_ = 0.0;
	gdouble _tmp120_ = 0.0;
	gdouble _tmp127_ = 0.0;
	gdouble _tmp128_ = 0.0;
	gdouble _tmp129_ = 0.0;
	gdouble _tmp130_ = 0.0;
	PlankDrawingColor _tmp131_ = {0};
	g_return_if_fail (source != NULL);
	rTotal = 0.0;
	gTotal = 0.0;
	bTotal = 0.0;
	bTotal2 = 0.0;
	gTotal2 = 0.0;
	rTotal2 = 0.0;
	aTotal2 = 0.0;
	_tmp0_ = source;
	_tmp1_ = gdk_pixbuf_get_pixels (_tmp0_);
	dataPtr = _tmp1_;
	_tmp2_ = source;
	_tmp3_ = gdk_pixbuf_get_n_channels (_tmp2_);
	_tmp4_ = _tmp3_;
	n_channels = _tmp4_;
	_tmp5_ = source;
	_tmp6_ = gdk_pixbuf_get_width (_tmp5_);
	_tmp7_ = _tmp6_;
	width = _tmp7_;
	_tmp8_ = source;
	_tmp9_ = gdk_pixbuf_get_height (_tmp8_);
	_tmp10_ = _tmp9_;
	height = _tmp10_;
	_tmp11_ = source;
	_tmp12_ = gdk_pixbuf_get_rowstride (_tmp11_);
	_tmp13_ = _tmp12_;
	rowstride = _tmp13_;
	_tmp14_ = width;
	_tmp15_ = height;
	length = _tmp14_ * _tmp15_;
	_tmp16_ = height;
	_tmp17_ = rowstride;
	_tmp18_ = n_channels;
	pixels = (_tmp16_ * _tmp17_) / _tmp18_;
	scoreTotal = 0.0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp19_ = FALSE;
			_tmp19_ = TRUE;
			while (TRUE) {
				gint _tmp21_ = 0;
				gint _tmp22_ = 0;
				guint8* _tmp23_ = NULL;
				guint8 _tmp24_ = 0U;
				guint8* _tmp25_ = NULL;
				guint8 _tmp26_ = 0U;
				guint8* _tmp27_ = NULL;
				guint8 _tmp28_ = 0U;
				guint8* _tmp29_ = NULL;
				guint8 _tmp30_ = 0U;
				guint8 _tmp31_ = 0U;
				guint8 _tmp35_ = 0U;
				guint8 _tmp36_ = 0U;
				guint8 _tmp37_ = 0U;
				guint8 _tmp38_ = 0U;
				guint8 _tmp39_ = 0U;
				guint8 _tmp40_ = 0U;
				guint8 _tmp41_ = 0U;
				guint8 _tmp42_ = 0U;
				guint8 _tmp43_ = 0U;
				guint8 _tmp44_ = 0U;
				guint8 _tmp45_ = 0U;
				guint8 _tmp46_ = 0U;
				gdouble _tmp47_ = 0.0;
				gdouble _tmp48_ = 0.0;
				gdouble score = 0.0;
				gdouble _tmp51_ = 0.0;
				gdouble _tmp52_ = 0.0;
				guint8 _tmp53_ = 0U;
				guint8 _tmp54_ = 0U;
				gdouble _tmp55_ = 0.0;
				gdouble _tmp56_ = 0.0;
				guint8 _tmp57_ = 0U;
				guint8 _tmp58_ = 0U;
				gdouble _tmp59_ = 0.0;
				gdouble _tmp60_ = 0.0;
				guint8 _tmp61_ = 0U;
				guint8 _tmp62_ = 0U;
				gdouble _tmp63_ = 0.0;
				gdouble _tmp64_ = 0.0;
				gdouble _tmp65_ = 0.0;
				guint8 _tmp66_ = 0U;
				gdouble _tmp67_ = 0.0;
				guint8 _tmp68_ = 0U;
				gdouble _tmp69_ = 0.0;
				guint8 _tmp70_ = 0U;
				gdouble _tmp71_ = 0.0;
				guint8 _tmp72_ = 0U;
				guint8* _tmp73_ = NULL;
				gint _tmp74_ = 0;
				if (!_tmp19_) {
					gint _tmp20_ = 0;
					_tmp20_ = i;
					i = _tmp20_ + 1;
				}
				_tmp19_ = FALSE;
				_tmp21_ = i;
				_tmp22_ = pixels;
				if (!(_tmp21_ < _tmp22_)) {
					break;
				}
				_tmp23_ = dataPtr;
				_tmp24_ = _tmp23_[0];
				r = _tmp24_;
				_tmp25_ = dataPtr;
				_tmp26_ = _tmp25_[1];
				g = _tmp26_;
				_tmp27_ = dataPtr;
				_tmp28_ = _tmp27_[2];
				b = _tmp28_;
				_tmp29_ = dataPtr;
				_tmp30_ = _tmp29_[3];
				a = _tmp30_;
				_tmp31_ = a;
				if (_tmp31_ <= PLANK_DRAWING_DRAWING_SERVICE_ALPHA_THRESHOLD) {
					gint _tmp32_ = 0;
					guint8* _tmp33_ = NULL;
					gint _tmp34_ = 0;
					_tmp32_ = length;
					length = _tmp32_ - 1;
					_tmp33_ = dataPtr;
					_tmp34_ = n_channels;
					dataPtr = _tmp33_ + _tmp34_;
					continue;
				}
				_tmp35_ = r;
				_tmp36_ = g;
				_tmp37_ = b;
				_tmp38_ = MIN (_tmp36_, _tmp37_);
				_tmp39_ = MIN (_tmp35_, _tmp38_);
				min = _tmp39_;
				_tmp40_ = r;
				_tmp41_ = g;
				_tmp42_ = b;
				_tmp43_ = MAX (_tmp41_, _tmp42_);
				_tmp44_ = MAX (_tmp40_, _tmp43_);
				max = _tmp44_;
				_tmp45_ = max;
				_tmp46_ = min;
				delta = (gdouble) (_tmp45_ - _tmp46_);
				_tmp48_ = delta;
				if (_tmp48_ == ((gdouble) 0)) {
					_tmp47_ = 0.0;
				} else {
					gdouble _tmp49_ = 0.0;
					guint8 _tmp50_ = 0U;
					_tmp49_ = delta;
					_tmp50_ = max;
					_tmp47_ = _tmp49_ / _tmp50_;
				}
				score = PLANK_DRAWING_DRAWING_SERVICE_SATURATION_WEIGHT * _tmp47_;
				_tmp51_ = bTotal;
				_tmp52_ = score;
				_tmp53_ = b;
				_tmp54_ = a;
				bTotal = _tmp51_ + ((_tmp52_ * _tmp53_) / _tmp54_);
				_tmp55_ = gTotal;
				_tmp56_ = score;
				_tmp57_ = g;
				_tmp58_ = a;
				gTotal = _tmp55_ + ((_tmp56_ * _tmp57_) / _tmp58_);
				_tmp59_ = rTotal;
				_tmp60_ = score;
				_tmp61_ = r;
				_tmp62_ = a;
				rTotal = _tmp59_ + ((_tmp60_ * _tmp61_) / _tmp62_);
				_tmp63_ = scoreTotal;
				_tmp64_ = score;
				scoreTotal = _tmp63_ + _tmp64_;
				_tmp65_ = bTotal2;
				_tmp66_ = b;
				bTotal2 = _tmp65_ + _tmp66_;
				_tmp67_ = gTotal2;
				_tmp68_ = g;
				gTotal2 = _tmp67_ + _tmp68_;
				_tmp69_ = rTotal2;
				_tmp70_ = r;
				rTotal2 = _tmp69_ + _tmp70_;
				_tmp71_ = aTotal2;
				_tmp72_ = a;
				aTotal2 = _tmp71_ + _tmp72_;
				_tmp73_ = dataPtr;
				_tmp74_ = n_channels;
				dataPtr = _tmp73_ + _tmp74_;
			}
		}
	}
	_tmp75_ = length;
	if (_tmp75_ <= 0) {
		PlankDrawingColor _tmp76_ = {0};
		_tmp76_.red = 0.0;
		_tmp76_.green = 0.0;
		_tmp76_.blue = 0.0;
		_tmp76_.alpha = 0.0;
		*result = _tmp76_;
		return;
	}
	_tmp77_ = scoreTotal;
	_tmp78_ = length;
	scoreTotal = _tmp77_ / _tmp78_;
	_tmp79_ = bTotal;
	_tmp80_ = length;
	bTotal = _tmp79_ / _tmp80_;
	_tmp81_ = gTotal;
	_tmp82_ = length;
	gTotal = _tmp81_ / _tmp82_;
	_tmp83_ = rTotal;
	_tmp84_ = length;
	rTotal = _tmp83_ / _tmp84_;
	_tmp85_ = scoreTotal;
	if (_tmp85_ > 0.0) {
		gdouble _tmp86_ = 0.0;
		gdouble _tmp87_ = 0.0;
		gdouble _tmp88_ = 0.0;
		gdouble _tmp89_ = 0.0;
		gdouble _tmp90_ = 0.0;
		gdouble _tmp91_ = 0.0;
		_tmp86_ = bTotal;
		_tmp87_ = scoreTotal;
		bTotal = _tmp86_ / _tmp87_;
		_tmp88_ = gTotal;
		_tmp89_ = scoreTotal;
		gTotal = _tmp88_ / _tmp89_;
		_tmp90_ = rTotal;
		_tmp91_ = scoreTotal;
		rTotal = _tmp90_ / _tmp91_;
	}
	_tmp92_ = bTotal2;
	_tmp93_ = length;
	bTotal2 = _tmp92_ / (_tmp93_ * G_MAXUINT8);
	_tmp94_ = gTotal2;
	_tmp95_ = length;
	gTotal2 = _tmp94_ / (_tmp95_ * G_MAXUINT8);
	_tmp96_ = rTotal2;
	_tmp97_ = length;
	rTotal2 = _tmp96_ / (_tmp97_ * G_MAXUINT8);
	_tmp98_ = aTotal2;
	_tmp99_ = length;
	aTotal2 = _tmp98_ / (_tmp99_ * G_MAXUINT8);
	_tmp100_ = scoreTotal;
	if (_tmp100_ <= PLANK_DRAWING_DRAWING_SERVICE_WEIGHT_THRESHOLD) {
		gdouble f = 0.0;
		gdouble _tmp101_ = 0.0;
		gdouble rf = 0.0;
		gdouble _tmp102_ = 0.0;
		gdouble _tmp103_ = 0.0;
		gdouble _tmp104_ = 0.0;
		gdouble _tmp105_ = 0.0;
		gdouble _tmp106_ = 0.0;
		gdouble _tmp107_ = 0.0;
		gdouble _tmp108_ = 0.0;
		gdouble _tmp109_ = 0.0;
		gdouble _tmp110_ = 0.0;
		gdouble _tmp111_ = 0.0;
		gdouble _tmp112_ = 0.0;
		gdouble _tmp113_ = 0.0;
		gdouble _tmp114_ = 0.0;
		_tmp101_ = scoreTotal;
		f = (1.0 / PLANK_DRAWING_DRAWING_SERVICE_WEIGHT_THRESHOLD) * _tmp101_;
		_tmp102_ = f;
		rf = 1.0 - _tmp102_;
		_tmp103_ = bTotal;
		_tmp104_ = f;
		_tmp105_ = bTotal2;
		_tmp106_ = rf;
		bTotal = (_tmp103_ * _tmp104_) + (_tmp105_ * _tmp106_);
		_tmp107_ = gTotal;
		_tmp108_ = f;
		_tmp109_ = gTotal2;
		_tmp110_ = rf;
		gTotal = (_tmp107_ * _tmp108_) + (_tmp109_ * _tmp110_);
		_tmp111_ = rTotal;
		_tmp112_ = f;
		_tmp113_ = rTotal2;
		_tmp114_ = rf;
		rTotal = (_tmp111_ * _tmp112_) + (_tmp113_ * _tmp114_);
	}
	_tmp115_ = rTotal;
	_tmp116_ = gTotal;
	_tmp117_ = bTotal;
	_tmp118_ = MAX (_tmp116_, _tmp117_);
	_tmp119_ = MAX (_tmp115_, _tmp118_);
	max_val = _tmp119_;
	_tmp120_ = max_val;
	if (_tmp120_ > 1.0) {
		gdouble _tmp121_ = 0.0;
		gdouble _tmp122_ = 0.0;
		gdouble _tmp123_ = 0.0;
		gdouble _tmp124_ = 0.0;
		gdouble _tmp125_ = 0.0;
		gdouble _tmp126_ = 0.0;
		_tmp121_ = bTotal;
		_tmp122_ = max_val;
		bTotal = _tmp121_ / _tmp122_;
		_tmp123_ = gTotal;
		_tmp124_ = max_val;
		gTotal = _tmp123_ / _tmp124_;
		_tmp125_ = rTotal;
		_tmp126_ = max_val;
		rTotal = _tmp125_ / _tmp126_;
	}
	_tmp127_ = rTotal;
	_tmp128_ = gTotal;
	_tmp129_ = bTotal;
	_tmp130_ = aTotal2;
	_tmp131_.red = _tmp127_;
	_tmp131_.green = _tmp128_;
	_tmp131_.blue = _tmp129_;
	_tmp131_.alpha = _tmp130_;
	*result = _tmp131_;
	return;
}


static void plank_drawing_drawing_service_class_init (PlankDrawingDrawingServiceClass * klass) {
	plank_drawing_drawing_service_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = plank_drawing_drawing_service_finalize;
}


static void plank_drawing_drawing_service_instance_init (PlankDrawingDrawingService * self) {
}


static void plank_drawing_drawing_service_finalize (GObject* obj) {
	PlankDrawingDrawingService * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_DRAWING_TYPE_DRAWING_SERVICE, PlankDrawingDrawingService);
	G_OBJECT_CLASS (plank_drawing_drawing_service_parent_class)->finalize (obj);
}


/**
 * Utility service for loading icons and working with pixbufs.
 */
GType plank_drawing_drawing_service_get_type (void) {
	static volatile gsize plank_drawing_drawing_service_type_id__volatile = 0;
	if (g_once_init_enter (&plank_drawing_drawing_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankDrawingDrawingServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_drawing_drawing_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDrawingDrawingService), 0, (GInstanceInitFunc) plank_drawing_drawing_service_instance_init, NULL };
		GType plank_drawing_drawing_service_type_id;
		plank_drawing_drawing_service_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankDrawingDrawingService", &g_define_type_info, 0);
		g_once_init_leave (&plank_drawing_drawing_service_type_id__volatile, plank_drawing_drawing_service_type_id);
	}
	return plank_drawing_drawing_service_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



